=== added directory 'pxgo_openoffice_reports'
=== added file 'pxgo_openoffice_reports/__init__.py'
--- pxgo_openoffice_reports/__init__.py	1970-01-01 00:00:00 +0000
+++ pxgo_openoffice_reports/__init__.py	2010-10-29 17:07:16 +0000
@@ -0,0 +1,31 @@
+# -*- coding: utf-8 -*-
+# -*- encoding: utf-8 -*-
+##############################################################################
+#
+#    OpenOffice Reports
+#    Copyright (C) 2009 Pexego Sistemas Informáticos. All Rights Reserved
+#    $Id$
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU General Public License as published by
+#    the Free Software Foundation, either version 3 of the License, or
+#    (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU General Public License for more details.
+#
+#    You should have received a copy of the GNU General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+##############################################################################
+
+"""
+OpenOffice Reports - Reporting Engine based on Relatorio and OpenOffice.
+"""
+__author__ = "Borja López Soilán (Pexego)"
+
+import openoffice_report
+import report_xml
+#import demo
\ No newline at end of file

=== added file 'pxgo_openoffice_reports/__openerp__.py'
--- pxgo_openoffice_reports/__openerp__.py	1970-01-01 00:00:00 +0000
+++ pxgo_openoffice_reports/__openerp__.py	2010-10-29 17:07:16 +0000
@@ -0,0 +1,115 @@
+# -*- coding: utf-8 -*-
+# -*- encoding: utf-8 -*-
+##############################################################################
+#
+#    OpenOffice Reports
+#    Copyright (C) 2009 Pexego Sistemas Informáticos. All Rights Reserved
+#    $Id$
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU General Public License as published by
+#    the Free Software Foundation, either version 3 of the License, or
+#    (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU General Public License for more details.
+#
+#    You should have received a copy of the GNU General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+##############################################################################
+#
+# OpenOffice Reports - Reporting Engine based on Relatorio and OpenOffice.
+#
+# Autor: Borja López Soilán (Pexego)
+#
+{
+        "name" : "Pexego OpenOffice Reports",
+        "version" : "0.2",
+        "author" : "Pexego",
+        "website" : "http://www.pexego.es",
+        "category" : "Enterprise Specific Modules",
+        "description": """Pexego OpenOffice Reports - Reporting Engine based on Relatorio and OpenOffice.
+
+Reporting engine that uses OpenOffice and Relatorio to create reports from several kind of templates (like an OpenDocument Text, a Microsoft Excel spreadsheet, or even a PowerPoint!) 
+and export them on several formats (i.e.: it may create a Microsoft Excel spreadsheet from a OpenDocument spreadshet template).
+
+Based on Relatorio (see http://relatorio.openhex.org/), PyODConverter (http://www.artofsolving.com/opensource/pyodconverter) and the Jasper Reports addon from Koo (https://code.launchpad.net/openobject-client-kde).
+
+
+*** FEATURES ***
+
+- The next template formats and output formats are supported:
+  * Text (any text format supported by OpenOffice like odt, doc, rtf, txt): 
+        pdf, html, odt, doc (MS Word 97), rtf, txt
+  * Web (hmtl): 
+        pdf, odt
+  * Spreadsheet (ods, xls): 
+        pdf, html, ods, xls (MS Excel 97), csv
+  * Presentation (odp, ppt): 
+        pdf, html, odp, ppt
+  * Drawing (odg): 
+        pdf, swf
+
+- Subreports (inserting another file anywhere on the document) are supported for text formats,
+  they are recursive (will be processed by the template system and may have their own subreports)
+  and they can be loaded from a binary field.
+  
+- Dynamic insertion of images is supported too, and they can be loaded from a file or a binary field.
+
+- Conditional statements (if) and repetitive structures (for) are supported. And they can be used in tables.
+
+
+*** TEMPLATE LANGUAGE ***
+
+Templates are based on Relatorio and Genshi, you might find useful this introduction to Relatorio: http://relatorio.openhex.org/wiki/IndepthIntroduction
+
+Some additional features, mainly related to OpenERP, where added:
+
+    - Support for subreports (text documents only).
+        * From OpenObject binary fields:
+            ${ subreport(object.file_field, object.filename_field) }
+        * From files on disk:
+            ${ subreport(filepath='/tmp/something.odt') }
+        * From buffers (open files, strings):
+            ${ subreport(source=buffer, source_format='odt') }
+
+    - Translations using the OpenERP translation engine:
+        ${ _("Object Name") }
+
+    - Access to attachments of an OpenObject:
+        * Get the attachment names:
+            ${ ', '.join([a.name for a in get_attachments(object)]) }
+        * Use the first attachment as a subreport (only text documents):
+            ${ subreport(get_attachments(object)[0].datas, get_attachments(object)[0].datas_fname) }
+
+    - Using images from fields:
+        * On a frame name (see Relatorio documentation about including images),
+            instead of "image: (file, mimetype)'",
+            use "image: ${ field_to_image(object.field) }"
+
+
+*** REQUIREMENTS ***
+
+- Relatorio (0.5.0 or better) for basic templating (odt->odt and ods->ods only),
+- OpenOffice (2.4 or better) and PyUno for file conversions and subreports.
+- Python Imaging Library (PIL) if you want to use images from binary fields.
+- PyCha (3.0 or better) if you want to use charts.
+- Genshi (0.5.1 or better) for using ${} instead of relatorio://
+
+        """,
+        "depends" : [
+                     'base',
+                     ],
+        "init_xml" : [],
+        "demo_xml" : [
+                     'demo/partner_demo_report.xml',
+                     ],
+        "update_xml" : [
+                     'security/ir.model.access.csv',
+                     'report_xml_view.xml',
+                        ],
+        "installable": True
+}

=== added directory 'pxgo_openoffice_reports/custom_reports'
=== added directory 'pxgo_openoffice_reports/demo'
=== added file 'pxgo_openoffice_reports/demo/__init__.py'
--- pxgo_openoffice_reports/demo/__init__.py	1970-01-01 00:00:00 +0000
+++ pxgo_openoffice_reports/demo/__init__.py	2010-10-29 17:07:16 +0000
@@ -0,0 +1,1 @@
+import report_parser
\ No newline at end of file

=== added file 'pxgo_openoffice_reports/demo/partner_demo.ods'
Binary files pxgo_openoffice_reports/demo/partner_demo.ods and pxgo_openoffice_reports/demo/partner_demo.ods differ
=== added file 'pxgo_openoffice_reports/demo/partner_demo.odt'
Binary files pxgo_openoffice_reports/demo/partner_demo.odt and pxgo_openoffice_reports/demo/partner_demo.odt differ
=== added file 'pxgo_openoffice_reports/demo/partner_demo_bar_chart.yaml'
--- pxgo_openoffice_reports/demo/partner_demo_bar_chart.yaml	1970-01-01 00:00:00 +0000
+++ pxgo_openoffice_reports/demo/partner_demo_bar_chart.yaml	2010-10-29 17:07:16 +0000
@@ -0,0 +1,32 @@
+options:
+    width: 800
+    height: 800
+    background:
+        hide: true
+    legend:
+        hide: true
+    padding:
+        bottom: 50
+        left: 120
+        right: 30
+        top: 10
+    axis:
+        x:
+            label: 'Credit limit'
+            rotate: 25
+            ticks:
+                {% for idx, partner in enumerate(objects) %}
+                - v: $idx
+                  label: $partner.name
+                {% end %}
+        y:
+            rotate: 25
+chart:
+    type: hbar
+    output_type: png
+    dataset:
+      - - ${_('Credit limit')}
+        -
+            {% for idx, partner in enumerate(objects) %}
+            - [$idx, $partner.credit_limit]
+            {% end %}
\ No newline at end of file

=== added file 'pxgo_openoffice_reports/demo/partner_demo_not_auto.odt'
Binary files pxgo_openoffice_reports/demo/partner_demo_not_auto.odt and pxgo_openoffice_reports/demo/partner_demo_not_auto.odt differ
=== added file 'pxgo_openoffice_reports/demo/partner_demo_ods_output.xls'
Binary files pxgo_openoffice_reports/demo/partner_demo_ods_output.xls and pxgo_openoffice_reports/demo/partner_demo_ods_output.xls differ
=== added file 'pxgo_openoffice_reports/demo/partner_demo_odt_output.pdf'
Binary files pxgo_openoffice_reports/demo/partner_demo_odt_output.pdf and pxgo_openoffice_reports/demo/partner_demo_odt_output.pdf differ
=== added file 'pxgo_openoffice_reports/demo/partner_demo_pie_chart.yaml'
--- pxgo_openoffice_reports/demo/partner_demo_pie_chart.yaml	1970-01-01 00:00:00 +0000
+++ pxgo_openoffice_reports/demo/partner_demo_pie_chart.yaml	2010-10-29 17:07:16 +0000
@@ -0,0 +1,23 @@
+options:
+    width: 400
+    height: 400
+    background:
+        hide: true
+    legend:
+        hide: true
+    padding: 
+        bottom: 10
+        left: 70
+        right: 10
+        top: 10
+    axis:
+        labelFontSize: 16
+chart:
+    type: pie
+    output_type: png
+    dataset:
+        {% for partner in objects %}
+        - - ${partner.id}
+          - - [0, $partner.credit_limit]
+        {% end %}
+

=== added file 'pxgo_openoffice_reports/demo/partner_demo_report.xml'
--- pxgo_openoffice_reports/demo/partner_demo_report.xml	1970-01-01 00:00:00 +0000
+++ pxgo_openoffice_reports/demo/partner_demo_report.xml	2010-10-29 17:07:16 +0000
@@ -0,0 +1,50 @@
+<?xml version="1.0" encoding="utf-8"?>
+<!-- 
+	OpenOffice Reports - Sample partner report
+	Autor: Borja López Soilán (Pexego) 
+-->
+<openerp>
+    <data>
+		
+    <!-- Sample odt partner report -->
+        <report id="report_pxgo_openoffice_reports_partner_demo"
+			string="OpenOffice Reports Demo (ODT->PDF)"
+			model="res.partner"
+			name="pxgo_openoffice_reports.partner_demo"
+			rml="pxgo_openoffice_reports/demo/partner_demo.odt"
+			auto="True"
+			header="False" />
+        <record model="ir.actions.report.xml" id="report_pxgo_openoffice_reports_partner_demo">
+            <field name="report_type">oo-pdf</field>
+        </record>
+
+	<!-- Sample ods partner report -->
+        <report id="report_pxgo_openoffice_reports_partner_demo_ods"
+			string="OpenOffice Reports Demo (ODS->XLS)"
+			model="res.partner"
+			name="pxgo_openoffice_reports.partner_demo_ods"
+			rml="pxgo_openoffice_reports/demo/partner_demo.ods"
+			auto="True"
+			header="False" />
+        <record model="ir.actions.report.xml" id="report_pxgo_openoffice_reports_partner_demo_ods">
+            <field name="report_type">oo-xls</field>
+        </record>
+
+        <!-- Sample odt partner with parser when you can add more attributes to context-->
+        <!-- It is commented because in demo data you cannot have python files, this report need report_parser.py file, if
+        you want to test it discommented and write import demo in __init__.py-->
+
+        <!--<report id="report_pxgo_openoffice_reports_partner_demo_ods_not_auto"
+			string="OpenOffice Reports Demo (ODT->PDF) not auto"
+			model="res.partner"
+			name="pxgo_openoffice_reports.partner_demo_ods_not_auto"
+			rml="pxgo_openoffice_reports/demo/partner_demo_not_auto.odt"
+			auto="False"
+			header="False" />
+        <record model="ir.actions.report.xml" id="report_pxgo_openoffice_reports_partner_demo_ods_not_auto">
+            <field name="report_type">oo-pdf</field>
+        </record>-->
+        
+    </data>
+</openerp>
+	
\ No newline at end of file

=== added file 'pxgo_openoffice_reports/demo/partner_demo_subreport.odt'
Binary files pxgo_openoffice_reports/demo/partner_demo_subreport.odt and pxgo_openoffice_reports/demo/partner_demo_subreport.odt differ
=== added file 'pxgo_openoffice_reports/demo/report_parser.py'
--- pxgo_openoffice_reports/demo/report_parser.py	1970-01-01 00:00:00 +0000
+++ pxgo_openoffice_reports/demo/report_parser.py	2010-10-29 17:07:16 +0000
@@ -0,0 +1,42 @@
+# -*- coding: utf-8 -*-
+##############################################################################
+#
+#    OpenERP, Open Source Management Solution
+#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
+#    $Id$
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU General Public License as published by
+#    the Free Software Foundation, either version 3 of the License, or
+#    (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU General Public License for more details.
+#
+#    You should have received a copy of the GNU General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+##############################################################################
+
+"""Add dummy function to context, it prints Hi! when you call it"""
+
+from addons.pxgo_openoffice_reports.openoffice_report import openoffice_report, OOReport
+
+class report_parser(OOReport):
+    """Add dummy function to context, it prints Hi! when you call it"""
+    def get_report_context(self):
+        """Add dummy function to context, it prints Hi! when you call it"""
+        res = super(report_parser, self).get_report_context()
+        res.update({
+            'print_hi': self.print_hi,
+        })
+        return res
+
+    def print_hi(self):
+        """Print Hi!"""
+        res = "Hi !"
+        return res
+
+openoffice_report('report.pxgo_openoffice_reports.partner_demo_ods_not_auto', 'res.partner', parser=report_parser)
\ No newline at end of file

=== added directory 'pxgo_openoffice_reports/i18n'
=== added file 'pxgo_openoffice_reports/i18n/ca.po'
--- pxgo_openoffice_reports/i18n/ca.po	1970-01-01 00:00:00 +0000
+++ pxgo_openoffice_reports/i18n/ca.po	2010-10-29 17:07:16 +0000
@@ -0,0 +1,200 @@
+# Catalan translation for openobject-addons
+# Copyright (c) 2010 Rosetta Contributors and Canonical Ltd 2010
+# This file is distributed under the same license as the openobject-addons package.
+# FIRST AUTHOR <EMAIL@ADDRESS>, 2010.
+#
+msgid ""
+msgstr ""
+"Project-Id-Version: openobject-addons\n"
+"Report-Msgid-Bugs-To: FULL NAME <EMAIL@ADDRESS>\n"
+"POT-Creation-Date: 2009-11-27 17:29+0000\n"
+"PO-Revision-Date: 2010-09-03 08:06+0000\n"
+"Last-Translator: OpenERP Administrators <Unknown>\n"
+"Language-Team: Catalan <ca@li.org>\n"
+"MIME-Version: 1.0\n"
+"Content-Type: text/plain; charset=UTF-8\n"
+"Content-Transfer-Encoding: 8bit\n"
+"X-Launchpad-Export-Date: 2010-09-29 05:32+0000\n"
+"X-Generator: Launchpad (build Unknown)\n"
+
+#. module: pxgo_openoffice_reports
+#: model:ir.module.module,description:pxgo_openoffice_reports.module_meta_information
+msgid ""
+"Pexego OpenOffice Reports - Reporting Engine based on Relatorio and "
+"OpenOffice.\n"
+"\n"
+"Reporting engine that uses OpenOffice and Relatorio to create reports from "
+"several kind of templates (like an OpenDocument Text, a Microsoft Excel "
+"spreadsheet, or even a PowerPoint!) \n"
+"and export them on several formats (i.e.: it may create a Microsoft Excel "
+"spreadsheet from a OpenDocument spreadshet template).\n"
+"\n"
+"Based on Relatorio (see http://relatorio.openhex.org/), PyODConverter "
+"(http://www.artofsolving.com/opensource/pyodconverter) and the Jasper "
+"Reports addon from Koo (https://code.launchpad.net/openobject-client-kde).\n"
+"\n"
+"\n"
+"*** FEATURES ***\n"
+"\n"
+"- The next template formats and output formats are supported:\n"
+"  * Text (any text format supported by OpenOffice like odt, doc, rtf, txt): "
+"\n"
+"        pdf, html, odt, doc (MS Word 97), rtf, txt\n"
+"  * Web (hmtl): \n"
+"        pdf, odt\n"
+"  * Spreadsheet (ods, xls): \n"
+"        pdf, html, ods, xls (MS Excel 97), csv\n"
+"  * Presentation (odp, ppt): \n"
+"        pdf, html, odp, ppt\n"
+"  * Drawing (odg): \n"
+"        pdf, swf\n"
+"\n"
+"- Subreports (inserting another file anywhere on the document) are supported "
+"for text formats,\n"
+"  they are recursive (will be processed by the template system and may have "
+"their own subreports)\n"
+"  and they can be loaded from a binary field.\n"
+"  \n"
+"- Dynamic insertion of images is supported too, and they can be loaded from "
+"a file or a binary field.\n"
+"\n"
+"- Conditional statements (if) and repetitive structures (for) are supported. "
+"And they can be used in tables.\n"
+"\n"
+"\n"
+"*** TEMPLATE LANGUAGE ***\n"
+"\n"
+"Templates are based on Relatorio and Genshi, you might find useful this "
+"introduction to Relatorio: "
+"http://relatorio.openhex.org/wiki/IndepthIntroduction\n"
+"\n"
+"Some additional features, mainly related to OpenERP, where added:\n"
+"\n"
+"    - Support for subreports (text documents only).\n"
+"        * From OpenObject binary fields:\n"
+"            ${ subreport(object.file_field, object.filename_field) }\n"
+"        * From files on disk:\n"
+"            ${ subreport(filepath='/tmp/something.odt') }\n"
+"        * From buffers (open files, strings):\n"
+"            ${ subreport(source=buffer, source_format='odt') }\n"
+"\n"
+"    - Translations using the OpenERP translation engine:\n"
+"        ${ _(\"Object Name\") }\n"
+"\n"
+"    - Access to attachments of an OpenObject:\n"
+"        * Get the attachment names:\n"
+"            ${ ', '.join([a.name for a in get_attachments(object)]) }\n"
+"        * Use the first attachment as a subreport (only text documents):\n"
+"            ${ subreport(get_attachments(object)[0].datas, "
+"get_attachments(object)[0].datas_fname) }\n"
+"\n"
+"    - Using images from fields:\n"
+"        * On a frame name (see Relatorio documentation about including "
+"images),\n"
+"            instead of \"image: (file, mimetype)'\",\n"
+"            use \"image: field_to_image(object.field)\"\n"
+"\n"
+"\n"
+"*** REQUIREMENTS ***\n"
+"\n"
+"- Relatorio (0.5.0 or better) for basic templating (odt->odt and ods->ods "
+"only),\n"
+"- OpenOffice (3.0 or better) and PyUno for file conversions and subreports.\n"
+"- Python Imaging Library (PIL) if you want to use images from binary "
+"fields.\n"
+"- PyCha (3.0 or better) if you want to use charts.\n"
+"\n"
+"        "
+msgstr ""
+"Informes OpenOffice Pexego - Motor d'informes basat en Relatorio i "
+"OpenOffice.\n"
+"\n"
+"Motor d'informes que utilitza OpenOffice i Relatorio per a crear informes a "
+"partir de varis tipus de plantilles (com un Text OpenDocument, un full de "
+"càlcul de Microsoft Excel, o fins i tot un PowerPoint!) \n"
+"i els exporta a varis formats (p.ex.: podeu crear un full de càlcul "
+"Microsoft Excel a partir d'una plantilla de full de càlcul OpenDocument).\n"
+"\n"
+"Basat en Relatorio (veure http://relatorio.openhex.org/), PyODConverter "
+"(http://www.artofsolving.com/opensource/pyodconverter) i el mòdul Jasper "
+"Reports de Koo (https://code.launchpad.net/openobject-client-kde).\n"
+"\n"
+"\n"
+"*** FUNCIONALITATS ***\n"
+"\n"
+"- Es suporten els següents formats de plantilla i de sortida:\n"
+"  * Text (qualsevol suportat per OpenOffice com odt, doc, rtf, txt): \n"
+"        pdf, html, odt, doc (MS Word 97), rtf, txt\n"
+"  * Web (hmtl): \n"
+"        pdf, odt\n"
+"  * Full de càlcul (ods, xls): \n"
+"        pdf, html, ods, xls (MS Excel 97), csv\n"
+"  * Presentació (odp, ppt): \n"
+"        pdf, html, odp, ppt\n"
+"  * Dibuix (odg): \n"
+"        pdf, swf\n"
+"\n"
+"- Suporta subinformes (inserir un altre fitxer en qualsevol lloc del "
+"document) per als formats de text,\n"
+"  són recursius (seran processats pel sistema de plantilles i poden tenir "
+"els seus propis subinformes)\n"
+"  i poden ser carregats des d'un camp binari.\n"
+"  \n"
+"- També suporta inserció dinàmica d'imatges, que poden ser carregades des "
+"d'un fitxer o un camp binari.\n"
+"\n"
+"- Suporta sentències condicionals (if) i estructures repetitives (for). I "
+"poden ser utilitzats en taules.\n"
+"\n"
+"\n"
+"*** IDIOMA DE LES PLANTILLES ***\n"
+"\n"
+"Les plantilles estan basades en Relatorio i Genshi, aquesta introducció a "
+"Relatorio podria resultar-vos d'utilitat: "
+"http://relatorio.openhex.org/wiki/IndepthIntroduction\n"
+"\n"
+"Es van afegir algunes funcionalitats addicionals, principalment relacionades "
+"amb OpenERP:\n"
+"\n"
+"    - Suport per a subinformes (només documents de text).\n"
+"        * Per a camps binaris d'OpenObject:\n"
+"            ${ subreport(object.file_field, object.filename_field) }\n"
+"        * Per a fitxers en disc:\n"
+"            ${ subreport(filepath='/tmp/something.odt') }\n"
+"        * Per a bufers (fitxers oberts, cadenes):\n"
+"            ${ subreport(source=buffer, source_format='odt') }\n"
+"\n"
+"    - Traduccions utilitzen el motor de traduccions d'OpenERP:\n"
+"        ${ _(\"Object Name\") }\n"
+"\n"
+"    - Accés als fitxers adjunts d'un OpenObject:\n"
+"        * Obtenir els noms dels adjunts:\n"
+"            ${ ', '.join([a.name for a in get_attachments(object)]) }\n"
+"        * Utilitzar el primer adjunt com un subinforme (només documents de "
+"text):\n"
+"            ${ subreport(get_attachments(object)[0].datas, "
+"get_attachments(object)[0].datas_fname) }\n"
+"\n"
+"    - Utilitzant imatges des de camps:\n"
+"        * En el nom d'un marc (vegeu la documentació de Relatorio sobre "
+"incloure imatges),\n"
+"            en lloc de \"image: (file, mimetype)'\",\n"
+"            utilitzeu \"image: field_to_image(object.field)\"\n"
+"\n"
+"\n"
+"*** REQUISITS ***\n"
+"\n"
+"- Relatorio (0.5.0 o mejor) per a plantilles bàsiques (només odt->odt y ods-"
+">ods),\n"
+"- OpenOffice (3.0 o mejor) i PyUno per a conversió de fitxers i "
+"subinformes.\n"
+"- Python Imaging Library (PIL) si voleu utilitzar imatges des de camps "
+"binaris.\n"
+"- PyCha (3.0. or millor) if voleu utilitzar diagrames.\n"
+"\n"
+"        "
+
+#. module: pxgo_openoffice_reports
+#: model:ir.module.module,shortdesc:pxgo_openoffice_reports.module_meta_information
+msgid "Pexego OpenOffice Reports"
+msgstr "Informes OpenOffice Pexego"

=== added file 'pxgo_openoffice_reports/i18n/es.po'
--- pxgo_openoffice_reports/i18n/es.po	1970-01-01 00:00:00 +0000
+++ pxgo_openoffice_reports/i18n/es.po	2010-10-29 17:07:16 +0000
@@ -0,0 +1,368 @@
+# Translation of OpenERP Server.
+# This file contains the translation of the following modules:
+#	* pxgo_openoffice_reports
+#
+msgid ""
+msgstr ""
+"Project-Id-Version: OpenERP Server 6.0.0-rc1\n"
+"Report-Msgid-Bugs-To: support@openerp.com\n"
+"POT-Creation-Date: 2010-10-29 08:32:31+0000\n"
+"PO-Revision-Date: 2010-10-29 10:40+0100\n"
+"Last-Translator: omar <omar@pexego.es>\n"
+"Language-Team: \n"
+"MIME-Version: 1.0\n"
+"Content-Type: text/plain; charset=UTF-8\n"
+"Content-Transfer-Encoding: 8bit\n"
+"Plural-Forms: \n"
+
+#. module: pxgo_openoffice_reports
+#: field:ir.actions.report.xml,openoffice_report:0
+msgid "Is OpenOffice Report?"
+msgstr "Informe de OpenOffice"
+
+#: model:ir.module.module,description:pxgo_openoffice_reports.module_meta_information
+msgid ""
+"Pexego OpenOffice Reports - Reporting Engine based on Relatorio and "
+"OpenOffice.\n"
+"\n"
+"Reporting engine that uses OpenOffice and Relatorio to create reports from "
+"several kind of templates (like an OpenDocument Text, a Microsoft Excel "
+"spreadsheet, or even a PowerPoint!) \n"
+"and export them on several formats (i.e.: it may create a Microsoft Excel "
+"spreadsheet from a OpenDocument spreadshet template).\n"
+"\n"
+"Based on Relatorio (see http://relatorio.openhex.org/), PyODConverter "
+"(http://www.artofsolving.com/opensource/pyodconverter) and the Jasper "
+"Reports addon from Koo (https://code.launchpad.net/openobject-client-kde).\n"
+"\n"
+"\n"
+"*** FEATURES ***\n"
+"\n"
+"- The next template formats and output formats are supported:\n"
+"  * Text (any text format supported by OpenOffice like odt, doc, rtf, txt): "
+"\n"
+"        pdf, html, odt, doc (MS Word 97), rtf, txt\n"
+"  * Web (hmtl): \n"
+"        pdf, odt\n"
+"  * Spreadsheet (ods, xls): \n"
+"        pdf, html, ods, xls (MS Excel 97), csv\n"
+"  * Presentation (odp, ppt): \n"
+"        pdf, html, odp, ppt\n"
+"  * Drawing (odg): \n"
+"        pdf, swf\n"
+"\n"
+"- Subreports (inserting another file anywhere on the document) are supported "
+"for text formats,\n"
+"  they are recursive (will be processed by the template system and may have "
+"their own subreports)\n"
+"  and they can be loaded from a binary field.\n"
+"  \n"
+"- Dynamic insertion of images is supported too, and they can be loaded from "
+"a file or a binary field.\n"
+"\n"
+"- Conditional statements (if) and repetitive structures (for) are supported. "
+"And they can be used in tables.\n"
+"\n"
+"\n"
+"*** TEMPLATE LANGUAGE ***\n"
+"\n"
+"Templates are based on Relatorio and Genshi, you might find useful this "
+"introduction to Relatorio: "
+"http://relatorio.openhex.org/wiki/IndepthIntroduction\n"
+"\n"
+"Some additional features, mainly related to OpenERP, where added:\n"
+"\n"
+"    - Support for subreports (text documents only).\n"
+"        * From OpenObject binary fields:\n"
+"            ${ subreport(object.file_field, object.filename_field) }\n"
+"        * From files on disk:\n"
+"            ${ subreport(filepath='/tmp/something.odt') }\n"
+"        * From buffers (open files, strings):\n"
+"            ${ subreport(source=buffer, source_format='odt') }\n"
+"\n"
+"    - Translations using the OpenERP translation engine:\n"
+"        ${ _(\"Object Name\") }\n"
+"\n"
+"    - Access to attachments of an OpenObject:\n"
+"        * Get the attachment names:\n"
+"            ${ ', '.join([a.name for a in get_attachments(object)]) }\n"
+"        * Use the first attachment as a subreport (only text documents):\n"
+"            ${ subreport(get_attachments(object)[0].datas, "
+"get_attachments(object)[0].datas_fname) }\n"
+"\n"
+"    - Using images from fields:\n"
+"        * On a frame name (see Relatorio documentation about including "
+"images),\n"
+"            instead of \"image: (file, mimetype)'\",\n"
+"            use \"image: field_to_image(object.field)\"\n"
+"\n"
+"\n"
+"*** REQUIREMENTS ***\n"
+"\n"
+"- Relatorio (0.5.0 or better) for basic templating (odt->odt and ods->ods "
+"only),\n"
+"- OpenOffice (2.4 or better) and PyUno for file conversions and subreports.\n"
+"- Python Imaging Library (PIL) if you want to use images from binary "
+"fields.\n"
+"- PyCha (3.0 or better) if you want to use charts.\n"
+"- Genshi (0.5.1 or better) for using ${} instead of relatorio://\n"
+"\n"
+"        "
+msgstr ""
+"Reportes OpenOffice Pexego - Motor de reportes basado en Relatorio y "
+"OpenOffice.\n"
+"\n"
+"Motor de reportes que usa OpenOffice y Relatorio para crear reportes a "
+"partir de varios tipos de plantillas (como un Texto OpenDocument, una hoja "
+"de cálculo de Microsoft Excel, ¡o incluso un PowerPoint!) \n"
+"y los exporta a varios formatos (p.ej.: puede crear una hoja de cálculo "
+"Microsoft Excel a partir de una plantilla de hoja de cálculo OpenDocument).\n"
+"\n"
+"Basado en Relatorio (ver http://relatorio.openhex.org/), PyODConverter "
+"(http://www.artofsolving.com/opensource/pyodconverter) y el módulo Jasper "
+"Reports de Koo (https://code.launchpad.net/openobject-client-kde).\n"
+"\n"
+"\n"
+"*** FUNCIONALIDADES ***\n"
+"\n"
+"- Se soportan los siguientes formatos de plantilla y de salida:\n"
+"  * Texto (cualquiera soportado por OpenOffice como odt, doc, rtf, txt): \n"
+"        pdf, html, odt, doc (MS Word 97), rtf, txt\n"
+"  * Web (hmtl): \n"
+"        pdf, odt\n"
+"  * Hoja de cálculo (ods, xls): \n"
+"        pdf, html, ods, xls (MS Excel 97), csv\n"
+"  * Presentación (odp, ppt): \n"
+"        pdf, html, odp, ppt\n"
+"  * Dibujo (odg): \n"
+"        pdf, swf\n"
+"\n"
+"- Soporta subreportes (insertar otro archivo en cualquier lugar del "
+"documento) para los formatos de texto,\n"
+"  son recursivos (serán procesados por el sistema de plantillas y pueden "
+"tener sus propios subreportes)\n"
+"  y pueden ser cargados desde un campo binario.\n"
+"  \n"
+"- También soporta inserción dinámica de imágenes, que pueden ser cargadas "
+"desde un archivo o un campo binario.\n"
+"\n"
+"- Soporta sentencias condicionales (if) y estructuras repetitivas (for). Y "
+"pueden ser usados en tablas.\n"
+"\n"
+"\n"
+"*** IDIOMA DE LAS PLANTILLAS ***\n"
+"\n"
+"Las plantillas están basadas en Relatorio y Genshi, esta introducción a "
+"Relatorio podría resultarle de utilidad: "
+"http://relatorio.openhex.org/wiki/IndepthIntroduction\n"
+"\n"
+"Se añadieron algunas funcionalidades adicionales, principalmente "
+"relacionadas con OpenERP:\n"
+"\n"
+"    - Soporte para subreportes (sólo documentos de texto).\n"
+"        * Para campos binarios de OpenObject:\n"
+"            ${ subreport(object.file_field, object.filename_field) }\n"
+"        * Para archivos en disco:\n"
+"            ${ subreport(filepath='/tmp/something.odt') }\n"
+"        * Para buferes (archivos abiertos, cadenas):\n"
+"            ${ subreport(source=buffer, source_format='odt') }\n"
+"\n"
+"    - Traducciones usando el motor de traducciones de OpenERP:\n"
+"        ${ _(\"Object Name\") }\n"
+"\n"
+"    - Acceso a los archivos adjuntos de un OpenObject:\n"
+"        * Obtener los nombres de los adjuntos:\n"
+"            ${ ', '.join([a.name for a in get_attachments(object)]) }\n"
+"        * Usar el primer adjunto como un subreporte (sólo documentos de "
+"texto):\n"
+"            ${ subreport(get_attachments(object)[0].datas, "
+"get_attachments(object)[0].datas_fname) }\n"
+"\n"
+"    - Usando imágenes desde campos:\n"
+"        * En el nombre de un marco (vea la documentación de Relatorio acerca "
+"de incluir imágenes),\n"
+"            en vez de \"image: (file, mimetype)'\",\n"
+"            use \"image: field_to_image(object.field)\"\n"
+"\n"
+"\n"
+"*** REQUISITOS ***\n"
+"\n"
+"- Relatorio (0.5.0 o mejor) para plantillas básicas (sólo odt->odt y ods-"
+">ods),\n"
+"- OpenOffice (2.4 o mejor) y PyUno para conversión de archivos y "
+"subreportes.\n"
+"- Python Imaging Library (PIL) si quieres usar imágenes desde campos "
+"binarios.\n"
+"- PyCha (3.0. o mejor) if quieres usar diagramas.\n"
+"- Genshi (0.5.1 o mejor) para usar expresiones ${} en lugar de relatorio://\n"
+"\n"
+"        "
+
+#. module: pxgo_openoffice_reports
+#: code:addons/pxgo_openoffice_reports/openoffice_report.py:0
+#, python-format
+msgid "Error loading the OpenOffice template: %s"
+msgstr "Error cargando la plantilla de OpenOffice: %s"
+
+#. module: pxgo_openoffice_reports
+#: model:ir.ui.menu,name:pxgo_openoffice_reports.openoffice_reports_menu
+msgid "OpenOffice Reports"
+msgstr "Informes OpenOffice"
+
+#. module: pxgo_openoffice_reports
+#: constraint:ir.model:0
+msgid "The Object name must start with x_ and not contain any special character !"
+msgstr "¡El nombre del objeto debe empezar con x_ y no contener ningún carácter especial!"
+
+#. module: pxgo_openoffice_reports
+#: constraint:ir.actions.act_window:0
+msgid "Invalid model name in the action definition."
+msgstr "Nombre de modelo no válido en la definición de acción."
+
+#. module: pxgo_openoffice_reports
+#: code:addons/pxgo_openoffice_reports/openoffice_report.py:0
+#, python-format
+msgid "Error processing the OpenOffice template: %s"
+msgstr "Error procesando la plantilla de OpenOffice: %s"
+
+#. module: pxgo_openoffice_reports
+#: constraint:ir.ui.view:0
+msgid "Invalid XML for View Architecture!"
+msgstr "¡XML inválido para la definición de la vista!"
+
+#. module: pxgo_openoffice_reports
+#: view:ir.actions.report.xml:0
+msgid "openoffice Reports"
+msgstr "Informes OpenOffice"
+
+#. module: pxgo_openoffice_reports
+#: constraint:ir.ui.menu:0
+msgid "Error ! You can not create recursive Menu."
+msgstr "¡ Error ! No puede crear menús recursivos."
+
+#. module: pxgo_openoffice_reports
+#: model:ir.actions.report.xml,name:pxgo_openoffice_reports.report_pxgo_openoffice_reports_partner_demo_ods
+msgid "OpenOffice Reports Demo (ODS->XLS)"
+msgstr "Informe OpenOffice demo (ODS->XLS)"
+
+#. module: pxgo_openoffice_reports
+#: view:ir.actions.report.xml:0
+#: field:ir.actions.report.xml,openoffice_file_ids:0
+msgid "Files"
+msgstr "Ficheros"
+
+#. module: pxgo_openoffice_reports
+#: view:ir.actions.report.xml.file:0
+msgid "Openoffice Reports File"
+msgstr "Fichero informe Openoffice"
+
+#. module: pxgo_openoffice_reports
+#: model:ir.actions.act_window,name:pxgo_openoffice_reports.ir_action_report_openoffice
+#: view:ir.actions.report.xml:0
+#: model:ir.ui.menu,name:pxgo_openoffice_reports.menu_ir_action_report_openoffice
+msgid "Openoffice Reports"
+msgstr "Informes Openoffice"
+
+#. module: pxgo_openoffice_reports
+#: view:ir.actions.report.xml:0
+msgid "Update from attachments"
+msgstr "Actualizar desde adjuntos"
+
+#. module: pxgo_openoffice_reports
+#: code:addons/pxgo_openoffice_reports/oo_template.py:0
+#, python-format
+msgid "Error inserting file %s on the OpenOffice document: %s"
+msgstr "Error insertando el fichero %s en el documento de OpenOffice: %s"
+
+#. module: pxgo_openoffice_reports
+#: code:addons/pxgo_openoffice_reports/report_xml.py:0
+#, python-format
+msgid "There is more than one report marked as default"
+msgstr "Hay más de un informe marcado como por defecto."
+
+#. module: pxgo_openoffice_reports
+#: code:addons/pxgo_openoffice_reports/oo_template.py:0
+#, python-format
+msgid "Error saving file %s with OpenOffice: %s"
+msgstr "Error guardando el fichero %s con OpenOffice: %s"
+
+#. module: pxgo_openoffice_reports
+#: view:ir.actions.report.xml:0
+msgid "Groups"
+msgstr "Grupos"
+
+#. module: pxgo_openoffice_reports
+#: field:ir.actions.report.xml.file,report_id:0
+msgid "Report"
+msgstr "Informe"
+
+#. module: pxgo_openoffice_reports
+#: code:addons/pxgo_openoffice_reports/__openerp__.py:0
+#, python-format
+msgid "Object Name"
+msgstr "Nombre objeto"
+
+#. module: pxgo_openoffice_reports
+#: code:addons/pxgo_openoffice_reports/oo_template.py:0
+#, python-format
+msgid "Error loading file %s with OpenOffice: %s"
+msgstr "Error cargando el fichero %s con OpenOffice: %s"
+
+#. module: pxgo_openoffice_reports
+#: code:addons/pxgo_openoffice_reports/oo_template.py:0
+#, python-format
+msgid "Couldn't connect to OpenOffice. Make sure you have an OpenOffice instance running and listening on the %s port. Details: %s"
+msgstr "No se pudo conectar con OpenOffice. Asegúrese de tener una instancia de OpenOffice corriendo y escuchando el el puerto %s. Detalles: %s"
+
+#. module: pxgo_openoffice_reports
+#: model:ir.model,name:pxgo_openoffice_reports.model_ir_actions_report_xml_file
+msgid "ir.actions.report.xml.file"
+msgstr "ir.actions.report.xml.file"
+
+#. module: pxgo_openoffice_reports
+#: field:ir.actions.report.xml.file,default:0
+msgid "Default"
+msgstr "Por defecto"
+
+#. module: pxgo_openoffice_reports
+#: code:addons/pxgo_openoffice_reports/report_xml.py:0
+#, python-format
+msgid "No report has been marked as default."
+msgstr "Ningún informe ha sido marcado por defecto."
+
+#. module: pxgo_openoffice_reports
+#: code:addons/pxgo_openoffice_reports/report_xml.py:0
+#, python-format
+msgid "Error"
+msgstr "Error"
+
+#. module: pxgo_openoffice_reports
+#: field:ir.actions.report.xml,openoffice_model_id:0
+msgid "Model"
+msgstr "Modelo"
+
+#. module: pxgo_openoffice_reports
+#: model:ir.actions.report.xml,name:pxgo_openoffice_reports.report_pxgo_openoffice_reports_partner_demo
+msgid "OpenOffice Reports Demo (ODT->PDF)"
+msgstr "Informe OpenOffice demo (ODT->PDF)"
+
+#. module: pxgo_openoffice_reports
+#: field:ir.actions.report.xml.file,filename:0
+msgid "File Name"
+msgstr "Nombre fichero"
+
+#. module: pxgo_openoffice_reports
+#: model:ir.model,name:pxgo_openoffice_reports.model_ir_actions_report_xml
+msgid "ir.actions.report.xml"
+msgstr "ir.acciones.informe.xml"
+
+#. module: pxgo_openoffice_reports
+#: field:ir.actions.report.xml.file,file:0
+msgid "File"
+msgstr "Fichero"
+
+#. module: pxgo_openoffice_reports
+#: sql_constraint:ir.model.fields:0
+msgid "Size of the field can never be less than 1 !"
+msgstr "¡ El tamaño del campo no puede nunca ser menor que 1 !"
+

=== added file 'pxgo_openoffice_reports/i18n/it.po'
--- pxgo_openoffice_reports/i18n/it.po	1970-01-01 00:00:00 +0000
+++ pxgo_openoffice_reports/i18n/it.po	2010-10-29 17:07:16 +0000
@@ -0,0 +1,113 @@
+# Italian translation for openobject-addons
+# Copyright (c) 2010 Rosetta Contributors and Canonical Ltd 2010
+# This file is distributed under the same license as the openobject-addons package.
+# FIRST AUTHOR <EMAIL@ADDRESS>, 2010.
+#
+msgid ""
+msgstr ""
+"Project-Id-Version: openobject-addons\n"
+"Report-Msgid-Bugs-To: FULL NAME <EMAIL@ADDRESS>\n"
+"POT-Creation-Date: 2009-11-27 17:29+0000\n"
+"PO-Revision-Date: 2010-08-18 12:15+0000\n"
+"Last-Translator: OpenERP Administrators <Unknown>\n"
+"Language-Team: Italian <it@li.org>\n"
+"MIME-Version: 1.0\n"
+"Content-Type: text/plain; charset=UTF-8\n"
+"Content-Transfer-Encoding: 8bit\n"
+"X-Launchpad-Export-Date: 2010-09-29 05:32+0000\n"
+"X-Generator: Launchpad (build Unknown)\n"
+
+#. module: pxgo_openoffice_reports
+#: model:ir.module.module,description:pxgo_openoffice_reports.module_meta_information
+msgid ""
+"Pexego OpenOffice Reports - Reporting Engine based on Relatorio and "
+"OpenOffice.\n"
+"\n"
+"Reporting engine that uses OpenOffice and Relatorio to create reports from "
+"several kind of templates (like an OpenDocument Text, a Microsoft Excel "
+"spreadsheet, or even a PowerPoint!) \n"
+"and export them on several formats (i.e.: it may create a Microsoft Excel "
+"spreadsheet from a OpenDocument spreadshet template).\n"
+"\n"
+"Based on Relatorio (see http://relatorio.openhex.org/), PyODConverter "
+"(http://www.artofsolving.com/opensource/pyodconverter) and the Jasper "
+"Reports addon from Koo (https://code.launchpad.net/openobject-client-kde).\n"
+"\n"
+"\n"
+"*** FEATURES ***\n"
+"\n"
+"- The next template formats and output formats are supported:\n"
+"  * Text (any text format supported by OpenOffice like odt, doc, rtf, txt): "
+"\n"
+"        pdf, html, odt, doc (MS Word 97), rtf, txt\n"
+"  * Web (hmtl): \n"
+"        pdf, odt\n"
+"  * Spreadsheet (ods, xls): \n"
+"        pdf, html, ods, xls (MS Excel 97), csv\n"
+"  * Presentation (odp, ppt): \n"
+"        pdf, html, odp, ppt\n"
+"  * Drawing (odg): \n"
+"        pdf, swf\n"
+"\n"
+"- Subreports (inserting another file anywhere on the document) are supported "
+"for text formats,\n"
+"  they are recursive (will be processed by the template system and may have "
+"their own subreports)\n"
+"  and they can be loaded from a binary field.\n"
+"  \n"
+"- Dynamic insertion of images is supported too, and they can be loaded from "
+"a file or a binary field.\n"
+"\n"
+"- Conditional statements (if) and repetitive structures (for) are supported. "
+"And they can be used in tables.\n"
+"\n"
+"\n"
+"*** TEMPLATE LANGUAGE ***\n"
+"\n"
+"Templates are based on Relatorio and Genshi, you might find useful this "
+"introduction to Relatorio: "
+"http://relatorio.openhex.org/wiki/IndepthIntroduction\n"
+"\n"
+"Some additional features, mainly related to OpenERP, where added:\n"
+"\n"
+"    - Support for subreports (text documents only).\n"
+"        * From OpenObject binary fields:\n"
+"            ${ subreport(object.file_field, object.filename_field) }\n"
+"        * From files on disk:\n"
+"            ${ subreport(filepath='/tmp/something.odt') }\n"
+"        * From buffers (open files, strings):\n"
+"            ${ subreport(source=buffer, source_format='odt') }\n"
+"\n"
+"    - Translations using the OpenERP translation engine:\n"
+"        ${ _(\"Object Name\") }\n"
+"\n"
+"    - Access to attachments of an OpenObject:\n"
+"        * Get the attachment names:\n"
+"            ${ ', '.join([a.name for a in get_attachments(object)]) }\n"
+"        * Use the first attachment as a subreport (only text documents):\n"
+"            ${ subreport(get_attachments(object)[0].datas, "
+"get_attachments(object)[0].datas_fname) }\n"
+"\n"
+"    - Using images from fields:\n"
+"        * On a frame name (see Relatorio documentation about including "
+"images),\n"
+"            instead of \"image: (file, mimetype)'\",\n"
+"            use \"image: field_to_image(object.field)\"\n"
+"\n"
+"\n"
+"*** REQUIREMENTS ***\n"
+"\n"
+"- Relatorio (0.5.0 or better) for basic templating (odt->odt and ods->ods "
+"only),\n"
+"- OpenOffice (3.0 or better) and PyUno for file conversions and subreports.\n"
+"- Python Imaging Library (PIL) if you want to use images from binary "
+"fields.\n"
+"- PyCha (3.0 or better) if you want to use charts.\n"
+"\n"
+"        "
+msgstr ""
+
+#. module: pxgo_openoffice_reports
+#: model:ir.module.module,shortdesc:pxgo_openoffice_reports.module_meta_information
+msgid "Pexego OpenOffice Reports"
+msgstr "Reports OpenOffice Pexego"

=== added file 'pxgo_openoffice_reports/i18n/pxgo_openoffice_reports.pot'
--- pxgo_openoffice_reports/i18n/pxgo_openoffice_reports.pot	1970-01-01 00:00:00 +0000
+++ pxgo_openoffice_reports/i18n/pxgo_openoffice_reports.pot	2010-10-29 17:07:16 +0000
@@ -0,0 +1,280 @@
+# Translation of OpenERP Server.
+# This file contains the translation of the following modules:
+#	* pxgo_openoffice_reports
+#
+msgid ""
+msgstr ""
+"Project-Id-Version: OpenERP Server 6.0.0-rc1\n"
+"Report-Msgid-Bugs-To: support@openerp.com\n"
+"POT-Creation-Date: 2010-10-29 08:32:31+0000\n"
+"PO-Revision-Date: 2010-10-29 10:40+0100\n"
+"Last-Translator: omar <omar@pexego.es>\n"
+"Language-Team: \n"
+"MIME-Version: 1.0\n"
+"Content-Type: text/plain; charset=UTF-8\n"
+"Content-Transfer-Encoding: 8bit\n"
+"Plural-Forms: \n"
+
+#. module: pxgo_openoffice_reports
+#: field:ir.actions.report.xml,openoffice_report:0
+msgid "Is OpenOffice Report?"
+msgstr ""
+
+#: model:ir.module.module,description:pxgo_openoffice_reports.module_meta_information
+msgid ""
+"Pexego OpenOffice Reports - Reporting Engine based on Relatorio and "
+"OpenOffice.\n"
+"\n"
+"Reporting engine that uses OpenOffice and Relatorio to create reports from "
+"several kind of templates (like an OpenDocument Text, a Microsoft Excel "
+"spreadsheet, or even a PowerPoint!) \n"
+"and export them on several formats (i.e.: it may create a Microsoft Excel "
+"spreadsheet from a OpenDocument spreadshet template).\n"
+"\n"
+"Based on Relatorio (see http://relatorio.openhex.org/), PyODConverter "
+"(http://www.artofsolving.com/opensource/pyodconverter) and the Jasper "
+"Reports addon from Koo (https://code.launchpad.net/openobject-client-kde).\n"
+"\n"
+"\n"
+"*** FEATURES ***\n"
+"\n"
+"- The next template formats and output formats are supported:\n"
+"  * Text (any text format supported by OpenOffice like odt, doc, rtf, txt): "
+"\n"
+"        pdf, html, odt, doc (MS Word 97), rtf, txt\n"
+"  * Web (hmtl): \n"
+"        pdf, odt\n"
+"  * Spreadsheet (ods, xls): \n"
+"        pdf, html, ods, xls (MS Excel 97), csv\n"
+"  * Presentation (odp, ppt): \n"
+"        pdf, html, odp, ppt\n"
+"  * Drawing (odg): \n"
+"        pdf, swf\n"
+"\n"
+"- Subreports (inserting another file anywhere on the document) are supported "
+"for text formats,\n"
+"  they are recursive (will be processed by the template system and may have "
+"their own subreports)\n"
+"  and they can be loaded from a binary field.\n"
+"  \n"
+"- Dynamic insertion of images is supported too, and they can be loaded from "
+"a file or a binary field.\n"
+"\n"
+"- Conditional statements (if) and repetitive structures (for) are supported. "
+"And they can be used in tables.\n"
+"\n"
+"\n"
+"*** TEMPLATE LANGUAGE ***\n"
+"\n"
+"Templates are based on Relatorio and Genshi, you might find useful this "
+"introduction to Relatorio: "
+"http://relatorio.openhex.org/wiki/IndepthIntroduction\n"
+"\n"
+"Some additional features, mainly related to OpenERP, where added:\n"
+"\n"
+"    - Support for subreports (text documents only).\n"
+"        * From OpenObject binary fields:\n"
+"            ${ subreport(object.file_field, object.filename_field) }\n"
+"        * From files on disk:\n"
+"            ${ subreport(filepath='/tmp/something.odt') }\n"
+"        * From buffers (open files, strings):\n"
+"            ${ subreport(source=buffer, source_format='odt') }\n"
+"\n"
+"    - Translations using the OpenERP translation engine:\n"
+"        ${ _(\"Object Name\") }\n"
+"\n"
+"    - Access to attachments of an OpenObject:\n"
+"        * Get the attachment names:\n"
+"            ${ ', '.join([a.name for a in get_attachments(object)]) }\n"
+"        * Use the first attachment as a subreport (only text documents):\n"
+"            ${ subreport(get_attachments(object)[0].datas, "
+"get_attachments(object)[0].datas_fname) }\n"
+"\n"
+"    - Using images from fields:\n"
+"        * On a frame name (see Relatorio documentation about including "
+"images),\n"
+"            instead of \"image: (file, mimetype)'\",\n"
+"            use \"image: field_to_image(object.field)\"\n"
+"\n"
+"\n"
+"*** REQUIREMENTS ***\n"
+"\n"
+"- Relatorio (0.5.0 or better) for basic templating (odt->odt and ods->ods "
+"only),\n"
+"- OpenOffice (2.4 or better) and PyUno for file conversions and subreports.\n"
+"- Python Imaging Library (PIL) if you want to use images from binary "
+"fields.\n"
+"- PyCha (3.0 or better) if you want to use charts.\n"
+"- Genshi (0.5.1 or better) for using ${} instead of relatorio://\n"
+"\n"
+"        "
+msgstr ""
+
+#. module: pxgo_openoffice_reports
+#: code:addons/pxgo_openoffice_reports/openoffice_report.py:0
+#, python-format
+msgid "Error loading the OpenOffice template: %s"
+msgstr ""
+
+#. module: pxgo_openoffice_reports
+#: model:ir.ui.menu,name:pxgo_openoffice_reports.openoffice_reports_menu
+msgid "OpenOffice Reports"
+msgstr ""
+
+#. module: pxgo_openoffice_reports
+#: constraint:ir.model:0
+msgid "The Object name must start with x_ and not contain any special character !"
+msgstr ""
+
+#. module: pxgo_openoffice_reports
+#: constraint:ir.actions.act_window:0
+msgid "Invalid model name in the action definition."
+msgstr ""
+
+#. module: pxgo_openoffice_reports
+#: code:addons/pxgo_openoffice_reports/openoffice_report.py:0
+#, python-format
+msgid "Error processing the OpenOffice template: %s"
+msgstr ""
+
+#. module: pxgo_openoffice_reports
+#: constraint:ir.ui.view:0
+msgid "Invalid XML for View Architecture!"
+msgstr ""
+
+#. module: pxgo_openoffice_reports
+#: view:ir.actions.report.xml:0
+msgid "openoffice Reports"
+msgstr ""
+
+#. module: pxgo_openoffice_reports
+#: constraint:ir.ui.menu:0
+msgid "Error ! You can not create recursive Menu."
+msgstr ""
+
+#. module: pxgo_openoffice_reports
+#: model:ir.actions.report.xml,name:pxgo_openoffice_reports.report_pxgo_openoffice_reports_partner_demo_ods
+msgid "OpenOffice Reports Demo (ODS->XLS)"
+msgstr ""
+
+#. module: pxgo_openoffice_reports
+#: view:ir.actions.report.xml:0
+#: field:ir.actions.report.xml,openoffice_file_ids:0
+msgid "Files"
+msgstr ""
+
+#. module: pxgo_openoffice_reports
+#: view:ir.actions.report.xml.file:0
+msgid "Openoffice Reports File"
+msgstr ""
+
+#. module: pxgo_openoffice_reports
+#: model:ir.actions.act_window,name:pxgo_openoffice_reports.ir_action_report_openoffice
+#: view:ir.actions.report.xml:0
+#: model:ir.ui.menu,name:pxgo_openoffice_reports.menu_ir_action_report_openoffice
+msgid "Openoffice Reports"
+msgstr ""
+
+#. module: pxgo_openoffice_reports
+#: view:ir.actions.report.xml:0
+msgid "Update from attachments"
+msgstr ""
+
+#. module: pxgo_openoffice_reports
+#: code:addons/pxgo_openoffice_reports/oo_template.py:0
+#, python-format
+msgid "Error inserting file %s on the OpenOffice document: %s"
+msgstr ""
+
+#. module: pxgo_openoffice_reports
+#: code:addons/pxgo_openoffice_reports/report_xml.py:0
+#, python-format
+msgid "There is more than one report marked as default"
+msgstr ""
+
+#. module: pxgo_openoffice_reports
+#: code:addons/pxgo_openoffice_reports/oo_template.py:0
+#, python-format
+msgid "Error saving file %s with OpenOffice: %s"
+msgstr ""
+
+#. module: pxgo_openoffice_reports
+#: view:ir.actions.report.xml:0
+msgid "Groups"
+msgstr ""
+
+#. module: pxgo_openoffice_reports
+#: field:ir.actions.report.xml.file,report_id:0
+msgid "Report"
+msgstr ""
+
+#. module: pxgo_openoffice_reports
+#: code:addons/pxgo_openoffice_reports/__openerp__.py:0
+#, python-format
+msgid "Object Name"
+msgstr ""
+
+#. module: pxgo_openoffice_reports
+#: code:addons/pxgo_openoffice_reports/oo_template.py:0
+#, python-format
+msgid "Error loading file %s with OpenOffice: %s"
+msgstr ""
+
+#. module: pxgo_openoffice_reports
+#: code:addons/pxgo_openoffice_reports/oo_template.py:0
+#, python-format
+msgid "Couldn't connect to OpenOffice. Make sure you have an OpenOffice instance running and listening on the %s port. Details: %s"
+msgstr ""
+
+#. module: pxgo_openoffice_reports
+#: model:ir.model,name:pxgo_openoffice_reports.model_ir_actions_report_xml_file
+msgid "ir.actions.report.xml.file"
+msgstr ""
+
+#. module: pxgo_openoffice_reports
+#: field:ir.actions.report.xml.file,default:0
+msgid "Default"
+msgstr ""
+
+#. module: pxgo_openoffice_reports
+#: code:addons/pxgo_openoffice_reports/report_xml.py:0
+#, python-format
+msgid "No report has been marked as default."
+msgstr ""
+
+#. module: pxgo_openoffice_reports
+#: code:addons/pxgo_openoffice_reports/report_xml.py:0
+#, python-format
+msgid "Error"
+msgstr ""
+
+#. module: pxgo_openoffice_reports
+#: field:ir.actions.report.xml,openoffice_model_id:0
+msgid "Model"
+msgstr ""
+
+#. module: pxgo_openoffice_reports
+#: model:ir.actions.report.xml,name:pxgo_openoffice_reports.report_pxgo_openoffice_reports_partner_demo
+msgid "OpenOffice Reports Demo (ODT->PDF)"
+msgstr ""
+
+#. module: pxgo_openoffice_reports
+#: field:ir.actions.report.xml.file,filename:0
+msgid "File Name"
+msgstr ""
+
+#. module: pxgo_openoffice_reports
+#: model:ir.model,name:pxgo_openoffice_reports.model_ir_actions_report_xml
+msgid "ir.actions.report.xml"
+msgstr ""
+
+#. module: pxgo_openoffice_reports
+#: field:ir.actions.report.xml.file,file:0
+msgid "File"
+msgstr ""
+
+#. module: pxgo_openoffice_reports
+#: sql_constraint:ir.model.fields:0
+msgid "Size of the field can never be less than 1 !"
+msgstr ""
+

=== added file 'pxgo_openoffice_reports/oo_template.py'
--- pxgo_openoffice_reports/oo_template.py	1970-01-01 00:00:00 +0000
+++ pxgo_openoffice_reports/oo_template.py	2010-10-29 17:07:16 +0000
@@ -0,0 +1,599 @@
+# -*- coding: utf-8 -*-
+# -*- encoding: utf-8 -*-
+##############################################################################
+#
+#    OpenOffice Reports
+#    Copyright (C) 2009 Pexego Sistemas Informáticos. All Rights Reserved
+#    Based on Relatorio (see http://relatorio.openhex.org/)
+#       and PyODConverter (http://www.artofsolving.com/opensource/pyodconverter)
+#    $Id$
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU General Public License as published by
+#    the Free Software Foundation, either version 3 of the License, or
+#    (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU General Public License for more details.
+#
+#    You should have received a copy of the GNU General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+##############################################################################
+
+"""
+OpenOffice/Relatorio template engine.
+"""
+__author__ = "Borja López Soilán (Pexego)"
+
+from tools.translate import _
+import os
+import tempfile
+import inspect
+import base64
+import subprocess
+import time
+import genshi
+from os.path import abspath, splitext
+from relatorio.templates.opendocument import Template
+
+
+class OOTemplateException(Exception):
+    """
+    OpenOffice template exception
+    """
+    def __init__(self, message):
+        # pylint: disable-msg=W0231
+        self.message = message
+    def __str__(self):
+        return self.message
+
+
+class OOTemplate(Template):
+    """
+    OpenOffice/Relatorio template.
+    Extends the standard relatorio template to let the user include subreports
+    with the "${ subreport(file, context) }" statement,
+    and allow file conversions (pdf output and such).
+
+    Note: It needs an OpenOffice instance running and listening for the
+    advanced features.
+    """
+
+    def log(self, message):
+        """
+        Helper method used print debug messages
+        """
+        if self.logger:
+            self.logger(message)
+        else:
+            print "OOTemplate: %s" % message
+        
+
+    def __init__(self, source=None, filepath=None, filename=None, loader=None,
+                 encoding=None, lookup='strict', allow_exec=True,
+                 source_format=None, output_format=None,
+                 openoffice_port=8100, autostart_openoffice=True,
+                 logger=None):
+        """
+        Init the oo_subreports list, OpenOffice options and formats,
+        and then delegate on the parent constructor.
+        """
+        self.logger = logger
+
+        self.temp_file_names = [] # List of files to delete on the destructor (__del__)
+        assert filepath or filename or source_format
+
+        if source:
+            #
+            # Relatorio reports don't support using source instead of filepath/filename.
+            # Passing the file contents using source seems useful, but
+            # we will have to write it somewhere for Relatorio to work.
+            # So we will create a temp file (that will be removed when
+            # oo_render ends, and dump source to that file.
+            #
+            assert isinstance(source, (file, str, unicode))
+            self.log("Template is a file-like object or string, writing it to a temp file.")
+            dummy_fd, temp_file_name = tempfile.mkstemp(suffix=".%s" % source_format, prefix='openerp_oot_t_')
+            temp_file = open(temp_file_name, 'wb')
+            try:
+                if isinstance(source, file):
+                    temp_file.write(source.read())
+                elif isinstance(source, (str, unicode)):
+                    temp_file.write(source)
+            finally:
+                temp_file.close()
+            self.temp_file_names.append(temp_file_name)
+            filepath = temp_file_name
+
+        filepath = filepath or filename
+        filename = None
+        assert filepath
+
+        if not os.path.exists(filepath):
+            search_paths = ['./bin/addons/%s' % filepath, './addons/%s' % filepath]
+            for path in search_paths:
+                if os.path.exists(path):
+                    filepath = path
+                    break
+
+        if not source_format:
+            # Get the source_format from the file name:
+            source_format = splitext(filepath or filename)[1][1:]
+
+        assert source_format and output_format
+        source_format = source_format.lower()
+        output_format = output_format.lower()
+
+        if source_format in ('doc', 'rtf', 'txt', 'xls'):
+            # It's not an OpenDocument file,
+            # (it may be a Microsoft Word document [doc] for example),
+            # convert it using OpenOffice.
+            format_mapping = { 'doc': 'odt', 'rtf': 'odt', 'txt': 'odt', 'xls': 'ods'}
+            self.log("Template file is not an OpenDocument, converting from %s to %s." % (source_format, format_mapping[source_format]))
+            dummy_fd, temp_file_name = tempfile.mkstemp(suffix=".%s" % format_mapping[source_format], prefix='openerp_oot_t_')
+            oohelper = OOHelper(openoffice_port, autostart_openoffice, logger=self.logger)
+            document = oohelper.open_document(filepath)
+            oohelper.save_document(document, temp_file_name, close_document=True)
+            self.temp_file_names.append(temp_file_name)
+            source_format = format_mapping[source_format]
+            filepath = temp_file_name
+
+        self.source_format = source_format
+        self.output_format = output_format
+        self.openoffice_port = openoffice_port
+        self.autostart_openoffice = autostart_openoffice
+        self.oo_subreports = []
+
+        super(OOTemplate, self).__init__(source, filepath, filename, loader,
+                                       encoding, lookup, allow_exec)
+
+
+    def __del__(self):
+        """
+        Destructor of the template: Will delete any temp file created on the
+        constructor.
+        """
+        if self.temp_file_names:
+            for file_name in self.temp_file_names:
+                os.unlink(file_name)
+
+
+    def generate(self, *args, **kwargs):
+        """
+        Apply the template to the given context data.
+        Overwrites the generate method to add support for subreports.
+        Delegates on the standard generate method for everything else.
+        """
+        def _subreport(field=None, filename=None, source=None, filepath=None, source_format=None, encoding=None, context=None):
+            """
+            Method that can be referenced from the template to include subreports.
+            When called it will process the file as a template,
+            write the generated data to a temp file, 
+            and return a reference (filename) to this output file for later usage.
+            The OOTemplate will will use this data, after the main template
+            is generated, to do an insertion pass using UNO.
+            """
+            # Field is a binary field with a base64 encoded file that we will
+            # use as source if it is specified
+            source = field and base64.decodestring(field) or source
+
+            #
+            # Get the current report context so the subreport can see
+            # the variables defined on the report.
+            #
+            if not context:
+                context = {}
+                try:
+                    frame = inspect.stack()[1][0]
+                    locals_context = frame.f_locals.copy()
+                    data_context = locals_context.get('__data__') or context
+                    if data_context and isinstance(data_context, genshi.template.base.Context):
+                        for c in data_context.frames:
+                            context.update(c)
+                    else:
+                        context = data_context
+                except:
+                    self.log("Warning: Failed to get the context for the subreport from the stack frame!")
+
+
+            # Get the source_format from the file name:
+            if not source_format and (filepath or filename):
+                source_format = splitext(filepath or filename)[1][1:]
+            source_format = source_format or self.source_format
+            assert source_format
+
+            #
+            # Process the subreport file like a normal template
+            # (we are recursive!)
+            #
+            self.log("Generating subreport (%s)..." % source_format)
+            subreport_template = OOTemplate(source=source,
+                                filepath=filepath,
+                                filename=filename,
+                                encoding=encoding,
+                                source_format=source_format,
+                                output_format=self.source_format,
+                                openoffice_port=self.openoffice_port,
+                                autostart_openoffice=self.autostart_openoffice,
+                                logger=self.log)
+            data = subreport_template.oo_render(context)
+
+            #
+            # Save the subreport data to a temp file
+            #
+            dummy_fd, temp_file_name = tempfile.mkstemp(suffix=".%s" % source_format, prefix='openerp_oot_s_')
+            temp_file = open(temp_file_name, 'wb')
+            try:
+                temp_file.write(data)
+            finally:
+                temp_file.close()
+
+            #
+            # Save a reference to this file for later usage
+            #
+            self.oo_subreports.append(temp_file_name)
+            self.log("...subreport generated as %s." % temp_file_name)
+
+            # Return a placeholder that will be replaced later,
+            # on the insertion step, with the file contents:
+            return "${insert_doc('%s')}" % temp_file_name
+
+        # Add the include function to the report context
+        kwargs['subreport'] = _subreport
+
+        # Generate the template
+        res = super(OOTemplate, self).generate(*args, **kwargs)
+
+        return res
+
+
+
+    def oo_render(self, context=None):
+        """
+        Wrapper, around the render method of the original template,
+        that adds support for subreports and format conversion.
+        The wrapper is required as these operations need to be performed,
+        using OpenOffice, after the document generation by the template.
+        """
+        if context is None: context = {}
+        self.log("Generating report: step 1...")
+
+        # Generate the stream from the template (Relatorio)
+        data = self.generate(**context).render().getvalue()
+
+        self.log("...step 1 done.")
+
+        #
+        # Next steps need OpenOffice to perform some tasks
+        # like file insertion or format conversions.
+        # Using OpenOffice brings some overhead, so we will try to avoid
+        # connecting to it unless it is necesary.
+        #
+        if len(self.oo_subreports)>0 or (self.output_format != self.source_format):
+            self.log("Step 2....")
+
+            # Connect to OpenOffice
+            oohelper = OOHelper(self.openoffice_port, self.autostart_openoffice, logger=self.log)
+
+            #
+            # Create a temporary (input for OpenOffice) file
+            #
+            dummy_fd, temp_file_name = tempfile.mkstemp(suffix=".%s" % self.source_format, prefix='openerp_oot_i_')
+            temp_file = open(temp_file_name, 'wb')
+            try:
+                #
+                # Write the data to the file
+                #
+                try:
+                    temp_file.write(data)
+                finally:
+                    temp_file.close()
+
+                # Reopen the file with OpenOffice
+                document = oohelper.open_document(temp_file_name)
+
+                #
+                # Insert subreport files if needed
+                #
+                if len(self.oo_subreports)>0:
+                    self.log("Inserting subreport files")
+                    for subreport in self.oo_subreports:
+                        placeholder_text = "${insert_doc('%s')}" % subreport
+                        oohelper.replace_text_with_file_contents(document, placeholder_text, subreport)
+                        # Remove the subreport temp file
+                        os.unlink(subreport)
+
+                #
+                # Save the file (does the format conversion) on a temp file
+                #
+                dummy_fd, output_file_name = tempfile.mkstemp(suffix=".%s" % self.output_format, prefix='openerp_oot_o_')
+                try:
+                    # Save the document
+                    oohelper.save_document(document, output_file_name, close_document=True)
+
+                    #
+                    # Read back the data
+                    #
+                    output_file = open(output_file_name, 'rb')
+                    try:
+                        data = output_file.read()
+                    finally:
+                        output_file.close()
+                finally:
+                    # Remove the temp file
+                    os.unlink(output_file_name)
+            finally:
+                # Remove the temp file
+                os.unlink(temp_file_name)
+
+            self.log("...step 2 done.")
+
+
+        # TODO: As a long term feature it would be nice to be able to tell OpenOffice to refresh/recalculate the Table Of Contents (if there is any)
+
+
+        # Return the data (byte string)
+        return data
+
+
+
+
+class OOHelperException(Exception):
+    """
+    OpenOffice template exception
+    """
+    def __init__(self, message):
+        # pylint: disable-msg=W0231
+        self.message = message
+    def __str__(self):
+        return self.message
+
+
+
+class OOHelper():
+    """
+    OpenOffice helper methods.
+
+    Loads and saves OpenOffice documents, doing the needed format conversions.
+    Also lets you to replace text (placeholders) on documents with the contents
+    of another document.
+
+    Uses PyUNO, requires OpenOffice to be installed on the computer,
+    and a OpenOffice instance listening on the given port
+    (or it may start a headless OpenOffice instance for you).
+
+    Based on PyODConverter (http://www.artofsolving.com/opensource/pyodconverter)
+    """
+
+    # OpenOffice main executable posible paths
+    OOPATHS = [ '/usr/bin/soffice', '/usr/lib64/ooo-2.0/program/soffice', '/opt/openoffice.org3/program/soffice', 'C:\\Program Files\\OpenOffice.org 3.1\\program\\soffice', ]
+
+
+    #
+    # Import/export formats and filter options
+    #
+    # see http://wiki.services.openoffice.org/wiki/Framework/Article/Filter
+    #
+
+    #
+    # Import filter options (only formats that require options)
+    #
+    IMPORT_FILTER_MAP = {
+        'txt': { 'FilterName': 'Text (encoded)', 'FilterOptions': 'utf8' },
+        'csv': { 'FilterName': 'Text - txt - csv (StarCalc)', 'FilterOptions': '44,34,0' }
+    }
+
+    #
+    # Export filter mapping
+    #
+    EXPORT_FILTER_MAPS = {
+        'text': {
+            'pdf':      { "FilterName": "writer_pdf_Export" },
+            'html':     { "FilterName": "HTML (StarWriter)" },
+            'odt':      { "FilterName": "writer8" },
+            'doc':      { "FilterName": "MS Word 97" },
+            'rtf':      { "FilterName": "Rich Text Format" },
+            'txt':      { "FilterName": "Text", "FilterOptions": "utf8" }
+        },
+        'web': {
+            'pdf':      { "FilterName": "writer_web_pdf_Export" },
+            'odt':      { "FilterName": "writerweb8_writer" },
+        },
+        'spreadsheet': {
+            'pdf':      { "FilterName": "calc_pdf_Export" },
+            'html':     { "FilterName": "HTML (StarCalc)" },
+            'ods':      { "FilterName": "calc8" },
+            'xls':      { "FilterName": "MS Excel 97" },
+            'csv':      { "FilterName": "Text - txt - csv (StarCalc)", "FilterOptions": "44,34,0" }
+        },
+        'presentation': {
+            'pdf':      { "FilterName": "impress_pdf_Export" },
+            'html':     { "FilterName": "impress_html_Export" },
+            'odp':      { "FilterName": "impress8" },
+            'ppt':      { "FilterName": "MS PowerPoint 97" },
+            'ppt':      { "FilterName": "impress_flash_Export" },
+        },
+        'drawing': {
+            'pdf':      { "FilterName": "draw_pdf_Export" },
+            'swf':      { "FilterName": "draw_flash_Export" },
+        }
+    }
+
+
+    #
+    # Code ---------------------------------------------------------------------
+    #
+
+    def log(self, message):
+        """
+        Helper method used print debug messages
+        """
+        if self.logger:
+            self.logger(message)
+        else:
+            print "OOHelper: %s" % message
+
+
+    def __init__(self, openoffice_port=8100, autostart_openoffice=True, logger=None):
+        """
+        Initialize the default values and try to connect to OpenOffice
+        (or even start it).
+        """
+        import uno
+
+        self.logger = logger
+
+        self.port = openoffice_port
+        self.autostart = autostart_openoffice
+
+        #
+        # Try to connect with retries (to start OpenOffice if autostart_openoffice is enabled)
+        #
+        retry = 2
+        while retry:
+            retry = retry - 1
+            try:
+                self.log("Connecting to OpenOffice...")
+                local_component_context = uno.getComponentContext()
+                resolver = local_component_context.ServiceManager.createInstanceWithContext("com.sun.star.bridge.UnoUrlResolver", local_component_context)
+                component_context = resolver.resolve("uno:socket,host=localhost,port=%s;urp;StarOffice.ComponentContext" % self.port)
+                self.desktop = component_context.ServiceManager.createInstanceWithContext("com.sun.star.frame.Desktop", component_context)
+                self.log("...connected.")
+            except Exception, ex:
+                #
+                # Assume that the connection to OpenOffice has failed
+                # because OpenOffice is not running or listening
+                # and try to start it if autostart_openoffice.
+                #
+                self.log("...connection to OpenOffice failed!")
+                if autostart_openoffice and retry:
+                    #
+                    # Try to start a headless OpenOffice server
+                    #
+                    ooffice = None
+                    for path in self.OOPATHS:
+                        if os.path.exists(path):
+                            ooffice = path
+                            break
+                    if ooffice:
+                        self.log("Starting headless OpenOffice listener on port %s..." % self.port)
+                        subprocess.call([ooffice, '-headless', '-nofirststartwizard', '-accept=socket,host=localhost,port=%s;urp;' % self.port])
+                        # Wait for OO to start
+                        time.sleep(5)
+                        self.log("...trying again...")
+                else:
+                    raise OOHelperException(_("Couldn't connect to OpenOffice. Make sure you have an OpenOffice instance running and listening on the %s port. Details: %s") % (self.port, (hasattr(ex, 'value') and str(ex.value) or str(ex))))
+
+
+    def open_document(self, file_name):
+        """
+        Opens a document with OpenOffice
+        """
+        import uno
+        file_url = uno.systemPathToFileUrl(abspath(file_name))
+
+        if os.environ.get('OSTYPE', False) == 'FreeBSD':
+            # Workaround a problemas con OpenOffice 3.1 en FreeBSD
+            file_url = file_url.encode('UTF-8')
+
+        load_properties = { "Hidden": True }
+        file_ext = splitext(file_name)[1]
+        file_ext = file_ext and file_ext[1:].lower() or None
+        if self.IMPORT_FILTER_MAP.has_key(file_ext):
+            load_properties.update(self.IMPORT_FILTER_MAP[file_ext])
+
+        try:
+            document = self.desktop.loadComponentFromURL(file_url, "_blank", 0, self.make_properties(load_properties))
+        except Exception, ex:
+            raise OOHelperException(_("Error loading file %s with OpenOffice: %s") % (file_name, ex))
+        try:
+            document.refresh()
+        except AttributeError:
+            #print "Warning: Ignoring AttributeError on document refresh"
+            pass
+
+        return document
+
+
+    def save_document(self, document, file_name, close_document=True):
+        """
+        Saves a OpenOffice document to a file.
+        The file format will be detected (based on the file extension)
+        and the document will be converted to that format (see EXPORT_FILTER_MAPS).
+        """
+        import uno
+        file_url = uno.systemPathToFileUrl(abspath(file_name))
+        
+        if os.environ.get('OSTYPE', False) == 'FreeBSD':
+            # Workaround a problemas con OpenOffice 3.1 en FreeBSD
+            file_url = file_url.encode('UTF-8')
+
+        save_properties = { }
+
+        #
+        # Get the export filter options for the given file extension
+        #
+        file_ext = splitext(file_name)[1]
+        file_ext = file_ext and file_ext[1:].lower() or None
+
+        export_filter_map = \
+                (document.supportsService("com.sun.star.text.WebDocument") and self.EXPORT_FILTER_MAPS['web']) \
+                or (document.supportsService("com.sun.star.text.GenericTextDocument") and self.EXPORT_FILTER_MAPS['text']) \
+                or (document.supportsService("com.sun.star.sheet.SpreadsheetDocument") and self.EXPORT_FILTER_MAPS['spreadsheet']) \
+                or (document.supportsService("com.sun.star.presentation.PresentationDocument") and self.EXPORT_FILTER_MAPS['presentation']) \
+                or (document.supportsService("com.sun.star.drawing.DrawingDocument") and self.EXPORT_FILTER_MAPS['drawing'])
+
+        if export_filter_map and export_filter_map.has_key(file_ext):
+            save_properties.update(export_filter_map[file_ext])
+
+        #
+        # Save the document
+        #
+        try:
+            document.storeToURL(file_url, self.make_properties(save_properties))
+        except Exception, ex:
+            raise OOHelperException(_("Error saving file %s with OpenOffice: %s") % (file_name, ex))
+        finally:
+            if close_document:
+                document.close(True)
+
+
+
+    def replace_text_with_file_contents(self, document, placeholder_text, file_name):
+        """
+        Inserts the given file into the current document.
+        The file contents will replace the placeholder text.
+        """
+        import uno
+        file_url = uno.systemPathToFileUrl(abspath(file_name))
+
+        search = document.createSearchDescriptor()
+        search.SearchString = placeholder_text
+
+        found = document.findFirst( search )
+        while found:
+            try:
+                found.insertDocumentFromURL(file_url, ())
+            except Exception, ex:
+                raise OOHelperException(_("Error inserting file %s on the OpenOffice document: %s") % (file_name, ex))
+            found = document.findNext(found, search)
+
+
+    def make_properties(self, properties_dict):
+        """
+        Helper to create a tuple of PropertyValue items from a dictionary.
+        """
+        import uno
+        props = []
+        for key in properties_dict:
+            prop = uno.createUnoStruct("com.sun.star.beans.PropertyValue")
+            prop.Name = key
+            prop.Value = properties_dict[key]
+            props.append(prop)
+        return tuple(props)
+
+
+

=== added file 'pxgo_openoffice_reports/openoffice_report.py'
--- pxgo_openoffice_reports/openoffice_report.py	1970-01-01 00:00:00 +0000
+++ pxgo_openoffice_reports/openoffice_report.py	2010-10-29 17:07:16 +0000
@@ -0,0 +1,528 @@
+# -*- coding: utf-8 -*-
+# -*- encoding: utf-8 -*-
+##############################################################################
+#
+#    OpenOffice Reports
+#    Copyright (C) 2009 Pexego Sistemas Informáticos. All Rights Reserved
+#    $Id$
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU General Public License as published by
+#    the Free Software Foundation, either version 3 of the License, or
+#    (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU General Public License for more details.
+#
+#    You should have received a copy of the GNU General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+##############################################################################
+
+"""
+OpenOffice Reports - Reporting Engine based on Relatorio and OpenOffice.
+"""
+__author__ = "Borja López Soilán (Pexego)"
+
+import os
+import report
+import pooler
+import netsvc
+import base64
+import tempfile
+import re
+from tools.translate import _
+from oo_template import OOTemplate, OOTemplateException
+import mx.DateTime
+from datetime import datetime
+import time
+
+DT_FORMAT = '%Y-%m-%d'
+DHM_FORMAT = '%Y-%m-%d %H:%M:%S'
+HM_FORMAT = '%H:%M:%S'
+
+
+class OOReportException(Exception):
+    """
+    OpenERP report exception
+    """
+    def __init__(self, message):
+        # pylint: disable-msg=W0231
+        self.message = message
+    def __str__(self):
+        return self.message
+
+
+class OOReport(object):
+    """
+    OpenOffice/Relatorio based report.
+    """
+
+    def log(self, message, level=netsvc.LOG_DEBUG):
+        """
+        Helper method used print debug messages
+        """
+        netsvc.Logger().notifyChannel('pxgo_openffice_reports', level, message)
+
+
+    def __init__(self, name, cr, uid, ids, data, context):
+        self.name = name
+        self.cr = cr
+        self.uid = uid
+        self.ids = ids
+        self.data = data
+        self.model = self.data['model']
+        self.context = context or {}
+        self.dbname = cr.dbname
+        self.pool = pooler.get_pool( cr.dbname )
+        self.openoffice_port = 8100
+        self.autostart_openoffice = True
+        self.lang_dict_called = False
+        self.lang_dict = {}
+        self.default_lang = {}
+        self._transl_regex = re.compile('(\[\[.+?\]\])')
+
+
+    def get_report_context(self):
+        """
+        Returns the context for the report
+        (Template method pattern)
+        """
+        return {}
+
+
+    def _get_lang_dict(self):
+        """
+        Helper function that returns a function that
+        sets the language for one object using the current database
+        connection (cr) and user (uid).
+        """
+        pool_lang = self.pool.get('res.lang')
+        lang = self.context.get('lang', False) or 'en_US'
+        lang_ids = pool_lang.search(self.cr, self.uid, [('code','=',lang)])[0]
+        lang_obj = pool_lang.browse(self.cr, self.uid, lang_ids)
+        self.lang_dict.update({'lang_obj':lang_obj,'date_format':lang_obj.date_format,'time_format':lang_obj.time_format})
+        self.default_lang[lang] = self.lang_dict.copy()
+        return True
+
+    def get_digits(self, obj=None, f=None, dp=None):
+        """gets value for digits attribute"""
+        d = DEFAULT_DIGITS = 2
+        if dp:
+            decimal_precision_obj = self.pool.get('decimal.precision')
+            ids = decimal_precision_obj.search(self.cr, self.uid, [('name', '=', dp)])
+            if ids:
+                d = decimal_precision_obj.browse(self.cr, self.uid, ids)[0].digits
+        elif obj and f:
+            res_digits = getattr(obj._columns[f], 'digits', lambda x: ((16, DEFAULT_DIGITS)))
+            if isinstance(res_digits, tuple):
+                d = res_digits[1]
+            else:
+                d = res_digits(self.cr)[1]
+        elif (hasattr(obj, '_field') and\
+                isinstance(obj._field, (float_class, function_class)) and\
+                obj._field.digits):
+                d = obj._field.digits[1] or DEFAULT_DIGITS
+        return d
+
+    def execute(self, output_format='pdf', report_file_name=None):
+        """
+        Generate the report.
+        """
+
+        def _base64_to_string(field_value):
+            """
+            Helper method to decode a binary field
+            """
+            return base64.decodestring(field_value)
+
+        def _get_attachments():
+            """
+            Helper function that returns a function that
+            gets the attachments for one object using the current database
+            connection (cr) and user (uid).
+            """
+            def get_attachments_func(browse_object):
+                """
+                Returns the attachments for one browse_object
+                """
+                db, pool = pooler.get_db_and_pool(self.dbname)
+                cr = db.cursor()
+                att_facade = pool.get('ir.attachment')
+                # pylint: disable-msg=W0212
+                attachment_ids = att_facade.search(cr, self.uid, [
+                        ('res_model', '=', browse_object._name), 
+                        ('res_id', '=', browse_object.id)
+                    ])
+                return att_facade.browse(cr, self.uid, attachment_ids)
+            return get_attachments_func
+
+        def _field_to_image(field_value, rotate=None):
+            """
+            Helper function that decodes and converts a binary field
+            into a png image and returns a tuple like the ones Relatorio
+            "image:" directive wants.
+            """
+            from PIL import Image
+            data = base64.decodestring(field_value)
+            dummy_fd, temp_file_name = tempfile.mkstemp(prefix='openerp_oor_f2i_')
+            temp_file = open(temp_file_name, 'wb')
+            try:
+                temp_file.write(data)
+            finally:
+                temp_file.close()
+            image = Image.open(temp_file_name)
+            if rotate:
+                image = image.rotate(rotate)
+            image.save(temp_file_name, 'png')
+            return (open(temp_file_name, 'rb'), 'image/png')
+
+
+        def _chart_template_to_image(field=None, filename=None, source=None, filepath=None, source_format=None, encoding=None, context=None):
+            """
+            Method that can be referenced from the template to include
+            charts as images.
+            When called it will process the file as a chart template,
+            generate a png image, and return the data plus the mime type.
+            """
+            # Field is a binary field with a base64 encoded file that we will
+            # use as source if it is specified
+            source = field and base64.decodestring(field) or source
+
+            filepath = filepath or filename
+            filename = None
+            assert filepath
+
+            #
+            # Search for the file on the addons folder of OpenERP if the
+            # filepath does not exist.
+            #
+            if not os.path.exists(filepath):
+                search_paths = ['./bin/addons/%s' % filepath, './addons/%s' % filepath]
+                for path in search_paths:
+                    if os.path.exists(path):
+                        filepath = path
+                        break
+
+            #
+            # Genshi Base Template nor it's subclases
+            # (NewTextTemplate and chart.Template)
+            # seem to load the filepath/filename automatically;
+            # so we will read the file here if needed.
+            #
+            if not source:
+                file = open(filepath, 'rb')
+                try:
+                    source = file.read()
+                finally:
+                    file.close()
+
+            #
+            # Process the chart subreport file
+            #
+            self.log("Generating chart subreport...")
+            from relatorio.templates.chart import Template
+            chart_subreport_template = Template(source=source, encoding=encoding)
+            data = chart_subreport_template #.generate(**context)
+            self.log("...done, chart generated.")
+
+            return (data, 'image/png')
+
+
+        def _formatLang():
+            """
+            Helper function that returns a function that
+            formats received value to the language format.
+            """
+            def _format_lang(value, digits=None, date=False, date_time=False, grouping=True, monetary=False, dp=False):
+                """
+                    Assuming 'Account' decimal.precision=3:
+                        formatLang(value) -> digits=2 (default)
+                        formatLang(value, digits=4) -> digits=4
+                        formatLang(value, dp='Account') -> digits=3
+                        formatLang(value, digits=5, dp='Account') -> digits=5
+                """
+                if digits is None:
+                    if dp:
+                        digits = self.get_digits(dp=dp)
+                    else:
+                        digits = self.get_digits(value)
+
+                if isinstance(value, (str, unicode)) and not value:
+                    return ''
+
+                if not self.lang_dict_called:
+                    self._get_lang_dict()
+                    self.lang_dict_called = True
+
+                if date or date_time:
+                    if not str(value):
+                        return ''
+
+                    date_format = self.lang_dict['date_format']
+                    parse_format = DT_FORMAT
+                    if date_time:
+                        value=value.split('.')[0]
+                        date_format = date_format + " " + self.lang_dict['time_format']
+                        parse_format = DHM_FORMAT
+                    if not isinstance(value, time.struct_time):
+                        return time.strftime(date_format, time.strptime(value, parse_format))
+
+                    if not isinstance(value, time.struct_time):
+                        try:
+                            date = mx.DateTime.strptime(str(value),parse_format)
+                        except:# sometimes it takes converted values into value, so we dont need conversion.
+                            return str(value)
+                    else:
+                        date = datetime(*value.timetuple()[:6])
+                    return date.strftime(date_format)
+
+                return self.lang_dict['lang_obj'].format('%.' + str(digits) + 'f', value, grouping=grouping, monetary=monetary)
+            return _format_lang
+
+
+        def _format(text, oldtag=None):
+            """
+            Removes white spaces
+            """
+            return text.strip()
+
+
+        def translate():
+            def _translate(text):
+                lang = self.context['lang']
+                if lang and text and not text.isspace():
+                    transl_obj = self.pool.get('ir.translation')
+                    piece_list = self._transl_regex.split(text)
+                    for pn in range(len(piece_list)):
+                        if not self._transl_regex.match(piece_list[pn]):
+                            source_string = piece_list[pn].replace('\n', ' ').strip()
+                            if len(source_string):
+                                translated_string = transl_obj._get_source(self.cr, self.uid, self.name, ('report', 'rml'), lang, source_string)
+                                if translated_string:
+                                    piece_list[pn] = piece_list[pn].replace(source_string, translated_string)
+                    text = ''.join(piece_list)
+                return text
+            return _translate
+
+
+        def set_html_image():
+            def _set_htmlImage(id, model=None, field=None, context=None):
+                if not id :
+                    return ''
+                if not model:
+                    model = 'ir.attachment'
+                try :
+                    id = int(id)
+                    res = self.pool.get(model).read(self.cr,self.uid,id)
+                    if field :
+                        return res[field]
+                    elif model =='ir.attachment' :
+                        return res['datas']
+                    else:
+                        return ''
+                except Exception,e:
+                    return ''
+
+            return _set_htmlImage
+
+        def setLang():
+            """set lang to context"""
+            self.context['lang'] = lang
+            self.lang_dict_called = False
+
+
+
+        assert output_format
+
+        #
+        # Get the report path
+        #
+        if not report_file_name:
+            reports = self.pool.get( 'ir.actions.report.xml' )
+            report_ids = reports.search(self.cr, self.uid, [('report_name', '=', self.name[7:])], context=self.context)
+            report_file_name = reports.read(self.cr, self.uid, report_ids[0], ['report_rml'])['report_rml']
+            path = os.path.dirname(os.path.abspath(os.path.dirname(__file__)))
+            report_file_name = os.path.join(path, report_file_name)
+
+        #
+        # Set the variables that the report must see
+        #
+        context = self.context
+        context['objects'] = self.pool.get(self.model).browse(self.cr, self.uid, self.ids, self.context)
+        context['ids'] = self.ids
+        context['model'] = self.model
+        context['data'] = self.data
+
+        #
+        # Some aliases used on standard OpenERP reports
+        #
+        user = self.pool.get('res.users').browse(self.cr, self.uid, self.uid, self.context)
+        context['user'] = user
+        context['company'] = user.company_id
+        context['logo'] = user.company_id and user.company_id.logo
+        context['lang'] = context.get('lang') or (user.company_id and user.company_id.partner_id and user.company_id.partner_id.lang)
+
+        #
+        # Add some helper function aliases
+        #
+        context['base64_to_string'] = context.get('base64_to_string') or _base64_to_string
+        context['b2s'] = context.get('b2s') or _base64_to_string
+        context['get_attachments'] = context.get('get_attachments') or _get_attachments()
+        context['field_to_image'] = context.get('field_to_image') or _field_to_image
+        context['f2i'] = context.get('f2i') or _field_to_image
+        context['chart_template_to_image'] = context.get('chart_template_to_image') or _chart_template_to_image
+        context['chart'] = context.get('chart') or _chart_template_to_image
+        context['translate'] = context.get('translate') or translate()
+        context['_'] = context.get('_') or translate()
+        context['formatLang'] = context.get('formatLang') or _formatLang()
+        context['format'] = context.get('format') or _format
+        context['setHtmlImage'] = context.get('setHtmlImage') or set_html_image()
+        context['time'] = context.get('time') or time
+        context['setLang'] = context.get('setLang') or setLang
+
+        # Update the context with the custom report context
+        context.update(self.get_report_context())
+
+        #
+        # Process the template using the OpenOffice/Relatorio engine
+        #
+        data = self.process_template(report_file_name, output_format, context)
+
+        return data
+
+    def process_template(self, template_file, output_format, context=None):
+        """
+        Will process a relatorio template and return the name
+        of the temp output file.
+        """
+        if context is None: context = {}
+        #
+        # Get the template
+        #
+        self.log("Loading template %s from %s" % (self.name, template_file))
+        try:
+            template = OOTemplate(source=None,
+                            filepath=template_file,
+                            output_format=output_format,
+                            openoffice_port=self.openoffice_port,
+                            autostart_openoffice=self.autostart_openoffice,
+                            logger=self.log)
+        except OOTemplateException, ex:
+            raise OOReportException(_("Error loading the OpenOffice template: %s") % ex)
+
+        #
+        # Process the template
+        #
+        self.log("Rendering template %s as %s" % (self.name, output_format))
+        try:
+            data = template.oo_render(context=context)
+        except OOTemplateException, ex:
+            raise OOReportException(_("Error processing the OpenOffice template: %s") % ex)
+
+        return data
+
+
+
+class openoffice_report(report.interface.report_int):
+    """
+    Registers an OpenOffice/Relatorio report.
+    """
+
+    def __init__(self, name, model, parser=None, context=None):
+        if context is None: context = {}
+        # Remove report name from list of services if it already
+        # exists to avoid report_int's assert. We want to keep the
+        # automatic registration at login, but at the same time we
+        # need modules to be able to use a parser for certain reports.
+        if not name.startswith('report.'):
+            name = 'report.' + name
+        if name in netsvc.Service._services:
+            del netsvc.Service._services[name]
+        super(openoffice_report, self).__init__(name)
+        
+        self.model = model
+        self.parser = parser
+        self._context = context
+
+    def create(self, cr, uid, ids, datas, context=None):
+        """
+        Register the report with this handler.
+        """
+        name = self.name
+
+        reportClass = self.parser or OOReport
+
+
+        self._context.update(context)
+
+        #
+        # Find the output format
+        #
+        reports = pooler.get_pool(cr.dbname).get( 'ir.actions.report.xml' )
+        report_ids = reports.search(cr, uid, [('report_name', '=', name[7:])], context=context)
+        report_type = reports.read(cr, uid, report_ids[0], ['report_type'])['report_type']
+        if report_type.startswith('oo-'):
+            output_format = report_type.split('-')[1]
+        else:
+            output_format = 'pdf'
+
+        #
+        # Get the report
+        #
+        rpt = reportClass( name, cr, uid, ids, datas, self._context )
+        return (rpt.execute(output_format=output_format), output_format )
+
+
+#Allow call to old create method
+report.report_sxw.report_sxw.old_create = report.report_sxw.report_sxw.create
+
+def create(self, cr, uid, ids, data, context=None):
+    """
+    Wrapper around the create method of report_sxw
+    that registers 'automagically' OpenOffice reports.
+    """
+    if context is None: context = {}
+
+    if self.internal_header:
+        context.update({'internal_header': self.internal_header})
+    pool = pooler.get_pool(cr.dbname)
+    ir_obj = pool.get('ir.actions.report.xml')
+    report_xml_ids = ir_obj.search(cr, uid,
+            [('report_name', '=', self.name[7:])], context=context)
+
+    fnct_ret = False
+
+    if report_xml_ids:
+        report_xml = ir_obj.browse(cr, uid, report_xml_ids[0], context=context)
+    else:
+        title = ''
+        report_type= data.get('report_type', 'pdf')
+
+        if not report_type.startswith('oo-'):
+            fnct_ret = self.old_create(cr, uid, ids, data, context=context)
+        else:
+            rml = tools.file_open(self.tmpl, subdir=None).read()
+
+            class a(object):
+                def __init__(self, *args, **argv):
+                    for key,arg in argv.items():
+                        setattr(self, key, arg)
+
+            report_xml = a(title=title, report_type=report_type, report_rml_content=rml, name=title, attachment=False, header=self.header)
+
+    report_xml.header = False
+
+    if not fnct_ret:
+        oo_report = openoffice_report(self.name, data['model'], context=context)
+        fnct_ret = oo_report.create(cr, uid, ids, data, context)
+        if not fnct_ret:
+            return (False,False)
+
+    return fnct_ret
+
+#override create method
+report.report_sxw.report_sxw.create = create
+

=== added file 'pxgo_openoffice_reports/report_xml.py'
--- pxgo_openoffice_reports/report_xml.py	1970-01-01 00:00:00 +0000
+++ pxgo_openoffice_reports/report_xml.py	2010-10-29 17:07:16 +0000
@@ -0,0 +1,189 @@
+# -*- coding: utf-8 -*-
+# -*- encoding: utf-8 -*-
+##############################################################################
+#
+#    OpenOffice Reports
+#    Copyright (C) 2009 Pexego Sistemas Informáticos. All Rights Reserved
+#    $Id$
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU General Public License as published by
+#    the Free Software Foundation, either version 3 of the License, or
+#    (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU General Public License for more details.
+#
+#    You should have received a copy of the GNU General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+##############################################################################
+
+"""
+Extends report_xml to add new report types to the report_type selection.
+"""
+__author__ = "Borja López Soilán (Pexego)"
+
+import os
+import base64
+from osv import osv, fields
+import openoffice_report
+from tools.translate import _
+
+class report_xml_file(osv.osv):
+    _name = 'ir.actions.report.xml.file'
+    _columns = {
+        'file': fields.binary('File', required=True, filters="*.odt,*.pdf,*.html,*.doc,*.rtf,*.txt,*.ods,*.xls,*.csv,*.odp,*.ppt,*.swf", help=''),
+        'filename': fields.char('File Name', size=256, required=False, help=''),
+        'report_id': fields.many2one('ir.actions.report.xml', 'Report', required=True, ondelete='cascade', help=''),
+        'default': fields.boolean('Default', help=''),
+    }
+    def create(self, cr, uid, vals, context=None):
+        result = super(report_xml_file,self).create(cr, uid, vals, context)
+        self.pool.get('ir.actions.report.xml').update(cr, uid, [vals['report_id']], context)
+        return result
+
+    def write(self, cr, uid, ids, vals, context=None):
+        result = super(report_xml_file,self).write(cr, uid, ids, vals, context)
+        for attachment in self.browse(cr, uid, ids, context):
+            self.pool.get('ir.actions.report.xml').update(cr, uid, [attachment.report_id.id], context)
+        return result
+
+report_xml_file()
+
+class report_xml(osv.osv):
+    """
+    Extends report_xml to add new report types to the report_type selection.
+
+    You may declare reports of the new types like this
+        <report id="report_REPORTNAME"
+            ... />
+        <record model="ir.actions.report.xml" id="report_REPORTNAME">
+            <field name="report_type">oo-odt</field>
+        </record>
+    """
+    
+    _inherit = 'ir.actions.report.xml'
+
+    _columns = {
+        'report_type': fields.selection([
+                ('pdf', 'pdf'),
+                ('html', 'html'),
+                ('raw', 'raw'),
+                ('sxw', 'sxw'),
+                ('odt', 'odt'),
+                ('html2html','Html from html'),
+                ('oo-pdf', 'OpenOffice - pdf output'),
+                ('oo-html', 'OpenOffice - html output'),
+                ('oo-odt', 'OpenOffice - odt output'),
+                ('oo-doc', 'OpenOffice - doc output'),
+                ('oo-rtf', 'OpenOffice - rtf output'),
+                ('oo-txt', 'OpenOffice - txt output'),
+                ('oo-ods', 'OpenOffice - ods output'),
+                ('oo-xls', 'OpenOffice - xls output'),
+                ('oo-csv', 'OpenOffice - csv output'),
+                ('oo-odp', 'OpenOffice - odp output'),
+                ('oo-ppt', 'OpenOffice - ppt output'),
+                ('oo-swf', 'OpenOffice - swf output'),
+            ], string='Type', required=True),
+        'openoffice_file_ids': fields.one2many('ir.actions.report.xml.file', 'report_id', 'Files', help=''),
+        'openoffice_model_id': fields.many2one('ir.model', 'Model', help=''),
+        'openoffice_report': fields.boolean('Is OpenOffice Report?', help=''),
+    }
+
+    def create(self, cr, uid, vals, context=None):
+        if context and context.get('openoffice_report'):
+            vals['model'] = self.pool.get('ir.model').browse(cr, uid, vals['openoffice_model_id'], context).model
+            vals['type'] = 'ir.actions.report.xml'
+#            vals['report_type'] = 'pdf'
+            vals['openoffice_report'] = True
+            vals['header'] = False
+
+        return super(report_xml, self).create(cr, uid, vals, context)
+
+    def write(self, cr, uid, ids, vals, context=None):
+        if context and context.get('openoffice_report'):
+            if 'openoffice_model_id' in vals:
+                vals['model'] = self.pool.get('ir.model').browse(cr, uid, vals['openoffice_model_id'], context).model
+            vals['type'] = 'ir.actions.report.xml'
+#            vals['report_type'] = 'pdf'
+            vals['openoffice_report'] = True
+            vals['header'] = False
+
+        return super(report_xml, self).write(cr, uid, ids, vals, context)
+
+    def unlink(self, cr, uid, ids, context=None):
+        """Deletes ir_values register when you delete any ir.actions.report.xml"""
+        if context is None: context = {}
+        for report in self.browse(cr, uid, ids):
+            values = self.pool.get('ir.values').search(cr, uid, [('value','=','ir.actions.report.xml,%s'% report.id)])
+            if values:
+                self.pool.get('ir.values').unlink(cr, uid, values)
+
+        return super(report_xml, self).unlink(cr, uid, ids, context=context)
+
+    def update(self, cr, uid, ids, context={}):
+        """Browse attachments and store .odt into pxgo_openoffixe_reprots/custom_reports
+        directory. Also add or update ir.values data so they're shown on model views."""
+        for report in self.browse(cr, uid, ids):
+            has_default = False
+
+            for attachment in report.openoffice_file_ids:
+                content = attachment.file
+                fileName = attachment.filename
+
+                if not fileName or not content:
+                    continue
+
+                path = self.save_file( fileName, content )
+                for extension in ['.odt','.pdf','.html','.doc','.rtf','.txt','.ods','.xls','.csv','.odp','.ppt','.swf']:
+                    if extension in fileName:
+                        if attachment.default:
+                            if has_default:
+                                raise osv.except_osv(_('Error'), _('There is more than one report marked as default'))
+
+                            has_default = True
+                            # Update path into report_rml field.
+                            self.write(cr, uid, [report.id], {
+                                'report_rml': path
+                            })
+
+                            valuesId = self.pool.get('ir.values').search(cr, uid, [('value','=','ir.actions.report.xml,%s'% report.id)])
+                            data = {
+                                'name': report.name,
+                                'model': report.model,
+                                'key': 'action',
+                                'object': True,
+                                'key2': 'client_print_multi',
+                                'value': 'ir.actions.report.xml,%s'% report.id
+                            }
+                            
+                            if not valuesId:
+                                valuesId = self.pool.get('ir.values').create(cr, uid, data, context=context)
+                            else:
+                                self.pool.get('ir.values').write(cr, uid, valuesId, data, context=context)
+                                valuesId = valuesId[0]
+
+            if not has_default:
+                raise osv.except_osv(_('Error'), _('No report has been marked as default.'))
+
+            # Ensure the report is registered so it can be used immediately
+            openoffice_report.register_openoffice_report( report.report_name, report.model )
+            
+        return True
+
+    def save_file(self, name, value):
+        """save the file to pxgo_openoffice_reports/custom_reports"""
+        path = os.path.abspath( os.path.dirname(__file__) )
+        path += '/custom_reports/%s' % name
+        f = open( path, 'wb+' )
+        try:
+            f.write( base64.decodestring( value ) )
+        finally:
+            f.close()
+        path = 'pxgo_openoffice_reports/custom_reports/%s' % name
+        return path
+
+report_xml()

=== added file 'pxgo_openoffice_reports/report_xml_view.xml'
--- pxgo_openoffice_reports/report_xml_view.xml	1970-01-01 00:00:00 +0000
+++ pxgo_openoffice_reports/report_xml_view.xml	2010-10-29 17:07:16 +0000
@@ -0,0 +1,103 @@
+<?xml version="1.0"?>
+<openerp>
+<data>
+	<record id="act_report_xml_view" model="ir.ui.view">
+		<field name="name">ir.actions.report.xml.openoffice</field>
+		<field name="model">ir.actions.report.xml</field>
+		<field name="type">form</field>
+		<field name="inherit_id" ref="base.act_report_xml_view"/>
+		<field name="arch" type="xml">
+			<field name="report_name" position="after">
+				<button string="Update from attachments" name="update" type="object" colspan="2"/>
+			</field>
+		</field>
+	</record>
+
+	<record id="act_report_openoffice_file_form" model="ir.ui.view">
+            <field name="name">ir.actions.report.openoffice.file.form</field>
+            <field name="model">ir.actions.report.xml.file</field>
+            <field name="type">form</field>
+            <field name="arch" type="xml">
+                <form string="Openoffice Reports File">
+			<field name="file" filename="filename" colspan="4"/>
+			<field name="filename" colspan="4"/>
+			<field name="default" colspan="4"/>
+		</form>
+	    </field>
+	</record>
+	<record id="act_report_openoffice_file_tree" model="ir.ui.view">
+            <field name="name">ir.actions.report.openoffice.file.tree</field>
+            <field name="model">ir.actions.report.xml.file</field>
+            <field name="type">tree</field>
+            <field name="arch" type="xml">
+                <tree string="Openoffice Reports File">
+			<field name="filename"/>
+			<field name="default"/>
+		</tree>
+	    </field>
+	</record>
+
+        <record id="act_report_openoffice_form" model="ir.ui.view">
+            <field name="name">ir.actions.report.openoffice.form</field>
+            <field name="model">ir.actions.report.xml</field>
+            <field name="type">form</field>
+	    <field name="priority">20</field>
+            <field name="arch" type="xml">
+                <form string="openoffice Reports">
+                    <field name="name" select="1"/>
+                    <field name="openoffice_model_id" required="True" select="1"/>
+                    <field name="report_name" select="1"/>
+		            <field name="report_type" required="True" select="1"/>
+<!--                    <field name="attachment"/>-->
+<!--                    <field name="attachment_use"/>-->
+		    <separator string="Files" colspan="4"/>
+		    <field name="openoffice_file_ids" colspan="4" nolabel="1" />
+		    <separator string="Groups" colspan="4"/>
+                    <field name="groups_id" colspan="4" nolabel="1" />
+                </form>
+            </field>
+        </record>
+
+        <record id="act_report_openoffice_tree" model="ir.ui.view">
+            <field name="name">ir.actions.report.openoffice.tree</field>
+            <field name="model">ir.actions.report.xml</field>
+            <field name="type">tree</field>
+	    <field name="priority">20</field>
+            <field name="arch" type="xml">
+                <tree string="Openoffice Reports">
+                    <field name="name"/>
+		            <field name="openoffice_model_id"/>
+                    <field name="report_name"/>
+		            <field name="report_type"/>
+                    <field name="attachment"/>
+                </tree>
+            </field>
+        </record>
+
+
+        <record id="ir_action_report_openoffice" model="ir.actions.act_window">
+            <field name="name">Openoffice Reports</field>
+            <field name="type">ir.actions.act_window</field>
+            <field name="res_model">ir.actions.report.xml</field>
+            <field name="view_type">form</field>
+	    <field name="view_mode">tree,form</field>
+	    <field name="context">{'openoffice_report': True}</field>
+	    <field name="domain">[('openoffice_report','=',True)]</field>
+        </record>
+	<record id="ir_action_report_openoffice_view0" model="ir.actions.act_window.view">
+	    <field name="act_window_id" ref="ir_action_report_openoffice"/>
+	    <field name="view_mode">tree</field>
+	    <field name="view_id" ref="act_report_openoffice_tree"/>
+	    <field name="sequence">0</field>
+	</record>
+	<record id="ir_action_report_openoffice_view1" model="ir.actions.act_window.view">
+	    <field name="act_window_id" ref="ir_action_report_openoffice"/>
+	    <field name="view_mode">form</field>
+	    <field name="view_id" ref="act_report_openoffice_form"/>
+	    <field name="sequence">1</field>
+	</record>
+
+        <menuitem parent="base.menu_custom" name="OpenOffice Reports" id="openoffice_reports_menu"/>
+        <menuitem action="ir_action_report_openoffice" id="menu_ir_action_report_openoffice" parent="openoffice_reports_menu"/> 
+</data>
+</openerp>

=== added directory 'pxgo_openoffice_reports/security'
=== added file 'pxgo_openoffice_reports/security/ir.model.access.csv'
--- pxgo_openoffice_reports/security/ir.model.access.csv	1970-01-01 00:00:00 +0000
+++ pxgo_openoffice_reports/security/ir.model.access.csv	2010-10-29 17:07:16 +0000
@@ -0,0 +1,3 @@
+"id","name","model_id:id","group_id:id","perm_read","perm_write","perm_create","perm_unlink"
+"access_ir_actions_report_xml_file_all","ir_actions_report_xml_file","model_ir_actions_report_xml_file",,1,0,0,0
+"access_ir_actions_report_xml_file_group_system","ir_actions_report_xml_file_group_system","model_ir_actions_report_xml_file","base.group_system",1,1,1,1
\ No newline at end of file

